/* Fellow 1997 Petter Schau                */
/* Data used when initializing the cpu-emu */


#define SREG  0x00000007
#define SMOD  0x00000038
#define DMOD  0x000001c0
#define DREG  0x00000e00
#define SIZE  0x000000c0

#define BIT0  0x00000001
#define BIT1  0x00000002
#define BIT2  0x00000004
#define BIT3  0x00000008
#define BIT4  0x00000010
#define BIT5  0x00000020
#define BIT6  0x00000040
#define BIT7  0x00000080
#define BIT8  0x00000100
#define BIT9  0x00000200
#define BIT10 0x00000400
#define BIT11 0x00000800
#define BIT12 0x00001000
#define BIT13 0x00002000
#define BIT14 0x00004000
#define BIT15 0x00008000
#define BIT16 0x00010000
#define BIT17 0x00020000
#define BIT18 0x00040000
#define BIT19 0x00080000
#define BIT20 0x00100000
#define BIT21 0x00200000
#define BIT22 0x00400000
#define BIT23 0x00800000
#define BIT24 0x01000000
#define BIT25 0x02000000
#define BIT26 0x04000000
#define BIT27 0x08000000
#define BIT28 0x10000000
#define BIT29 0x20000000
#define BIT30 0x40000000
#define BIT31 0x80000000

extern ULO d[8];
extern ULO a[8];

/*
 External prototypes for the instructions
 They return the number of cycles used on a MC68000
 The disassembly routines return the instruction length in bytes
*/

extern void prepare_exception(void);

extern void next_instruction(void);
extern void i00(ULO);
extern void i01_1(ULO);
extern void i01_2(ULO);
extern void i02_B_1(ULO);
extern void i02_W_1(ULO);
extern void i02_L_1(ULO);
extern void i02_B_2(ULO);
extern void i02_W_2(ULO);
extern void i02_L_2(ULO);
extern void i03_W(ULO);
extern void i03_L(ULO);
extern void i04_B(ULO);
extern void i04_W(ULO);
extern void i04_L(ULO);
extern void i05_B(ULO);
extern void i05_W(ULO);
extern void i05_L(ULO);
extern void i05_ADR(ULO);
extern void i06_B_1(ULO);
extern void i06_W_1(ULO);
extern void i06_L_1(ULO);
extern void i06_B_2(ULO);
extern void i06_W_2(ULO);
extern void i06_L_2(ULO);
extern void i07_B_1(ULO);
extern void i07_W_1(ULO);
extern void i07_L_1(ULO);
extern void i07_B_2(ULO);
extern void i07_W_2(ULO);
extern void i07_L_2(ULO);
extern void i08_B(ULO);
extern void i08_W(ULO);
extern void i08_L(ULO);
extern void i08_B_CCR(ULO);
extern void i08_W_SR(ULO);
extern void i09_RI_I_B(ULO);
extern void i09_LE_I_B(ULO);
extern void i09_RI_I_W(ULO);
extern void i09_LE_I_W(ULO);
extern void i09_RI_I_L(ULO);
extern void i09_LE_I_L(ULO);
extern void i09_RI_R_B(ULO);
extern void i09_LE_R_B(ULO);
extern void i09_RI_R_W(ULO);
extern void i09_LE_R_W(ULO);
extern void i09_RI_R_L(ULO);
extern void i09_LE_R_L(ULO);
extern void i09_RI_M_W(ULO);
extern void i09_LE_M_W(ULO);
extern void i11_B(ULO);
extern void i11_W(ULO);
extern void i12_D_L(ULO);
extern void i12_D_B(ULO);
extern void i12_S_L(ULO);
extern void i12_S_B(ULO);
extern void i13_D_L(ULO);
extern void i13_D_B(ULO);
extern void i13_S_L(ULO);
extern void i13_S_B(ULO);   /* 14 is included in Bcc */
extern void i15_D_L(ULO);
extern void i15_D_B(ULO);
extern void i15_S_L(ULO);
extern void i15_S_B(ULO);   /* 16 is included in Bcc */
extern void i17_D_L(ULO);
extern void i17_D_B(ULO);
extern void i17_S_L(ULO);
extern void i17_S_B(ULO);
extern void i18(ULO);
extern void i19(ULO);
extern void i20_B(ULO);
extern void i20_W(ULO);
extern void i20_L(ULO);
extern void i21_W(ULO);
extern void i21_L(ULO);
extern void i22_B(ULO);
extern void i22_W(ULO);
extern void i22_L(ULO);
extern void i23_B(ULO);
extern void i23_W(ULO);
extern void i23_L(ULO);
extern void i24(ULO);
extern void i25(ULO);
extern void i26(ULO);
extern void i27_B(ULO);
extern void i27_W(ULO);
extern void i27_L(ULO);
extern void i28_B(ULO);
extern void i28_W(ULO);
extern void i28_L(ULO);
extern void i28_B_CCR(ULO);
extern void i28_W_SR(ULO);
extern void i29(ULO);
extern void i30_W(ULO);
extern void i30_L(ULO);
extern void i31(ULO);
extern void i32(ULO);
extern void i33(ULO);
extern void i34(ULO);
extern void i35_RI_I_B(ULO);
extern void i35_LE_I_B(ULO);
extern void i35_RI_I_W(ULO);
extern void i35_LE_I_W(ULO);
extern void i35_RI_I_L(ULO);
extern void i35_LE_I_L(ULO);
extern void i35_RI_R_B(ULO);
extern void i35_LE_R_B(ULO);
extern void i35_RI_R_W(ULO);
extern void i35_LE_R_W(ULO);
extern void i35_RI_R_L(ULO);
extern void i35_LE_R_L(ULO);
extern void i35_RI_M_W(ULO);
extern void i35_LE_M_W(ULO);
extern void i37_B(ULO);
extern void i37_W(ULO);
extern void i37_L(ULO);
extern void i38(ULO);
extern void i39(ULO);
extern void i40(ULO);
extern void i41_1(ULO);
extern void i41_2(ULO);
extern void i42_W(ULO);
extern void i42_L(ULO);
extern void i43_W_PREM(ULO);
extern void i43_L_PREM(ULO);
extern void i43_W_POSTR(ULO);
extern void i43_L_POSTR(ULO);
extern void i43_W_CONM(ULO);
extern void i43_L_CONM(ULO);
extern void i43_W_CONR(ULO);
extern void i43_L_CONR(ULO);
extern void i44_W_1(ULO);
extern void i44_L_1(ULO);
extern void i44_W_2(ULO);
extern void i44_L_2(ULO);
extern void i45(ULO);
extern void i46(ULO);
extern void i47(ULO);
extern void i48_B(ULO);
extern void i49_B(ULO);
extern void i49_W(ULO);
extern void i49_L(ULO);
extern void i50_B(ULO);
extern void i50_W(ULO);
extern void i50_L(ULO);
extern void i51(ULO);
extern void i52_B(ULO);
extern void i52_W(ULO);
extern void i52_L(ULO);
extern void i53_B_1(ULO);
extern void i53_W_1(ULO);
extern void i53_L_1(ULO);
extern void i53_B_2(ULO);
extern void i53_W_2(ULO);
extern void i53_L_2(ULO);
extern void i54_B(ULO);
extern void i54_W(ULO);
extern void i54_L(ULO);
extern void i54_B_CCR(ULO);
extern void i54_W_SR(ULO);
extern void i55(ULO);
extern void i56(ULO);
extern void i57_RI_I_B(ULO);
extern void i57_LE_I_B(ULO);
extern void i57_RI_I_W(ULO);
extern void i57_LE_I_W(ULO);
extern void i57_RI_I_L(ULO);
extern void i57_LE_I_L(ULO);
extern void i57_RI_R_B(ULO);
extern void i57_LE_R_B(ULO);
extern void i57_RI_R_W(ULO);
extern void i57_LE_R_W(ULO);
extern void i57_RI_R_L(ULO);
extern void i57_LE_R_L(ULO);
extern void i57_RI_M_W(ULO);
extern void i57_LE_M_W(ULO);
extern void i59_RI_I_B(ULO);
extern void i59_LE_I_B(ULO);
extern void i59_RI_I_W(ULO);
extern void i59_LE_I_W(ULO);
extern void i59_RI_I_L(ULO);
extern void i59_LE_I_L(ULO);
extern void i59_RI_R_B(ULO);
extern void i59_LE_R_B(ULO);
extern void i59_RI_R_W(ULO);
extern void i59_LE_R_W(ULO);
extern void i59_RI_R_L(ULO);
extern void i59_LE_R_L(ULO);
extern void i59_RI_M_W(ULO);
extern void i59_LE_M_W(ULO);
extern void i61(ULO);
extern void i62(ULO);
extern void i63(ULO);
extern void i64_1(ULO);
extern void i64_2(ULO);
extern void i65(ULO);
extern void i66(ULO);
extern void i67_B_1(ULO);
extern void i67_W_1(ULO);
extern void i67_L_1(ULO);
extern void i67_B_2(ULO);
extern void i67_W_2(ULO);
extern void i67_L_2(ULO);
extern void i68_W(ULO);
extern void i68_L(ULO);
extern void i69_B(ULO);
extern void i69_W(ULO);
extern void i69_L(ULO);
extern void i70_B(ULO);
extern void i70_W(ULO);
extern void i70_L(ULO);
extern void i70_ADR(ULO);
extern void i71_B_1(ULO);
extern void i71_W_1(ULO);
extern void i71_L_1(ULO);
extern void i71_B_2(ULO);
extern void i71_W_2(ULO);
extern void i71_L_2(ULO);
extern void i72(ULO);
extern void i73(ULO);
extern void i74(ULO);
extern void i75(ULO);
extern void i76_B(ULO);
extern void i76_W(ULO);
extern void i76_L(ULO);
extern void i77(ULO);

extern void cc0(void);
extern void cc1(void);
extern void cc2(void);
extern void cc3(void);
extern void cc4(void);
extern void cc5(void);
extern void cc6(void);
extern void cc7(void);
extern void cc8(void);
extern void cc9(void);
extern void cca(void);
extern void ccb(void);
extern void ccc(void);
extern void ccd(void);
extern void cce(void);
extern void ccf(void);
extern void cc1false(void);

extern ULO arb00(ULO);
extern ULO arb02(ULO);
extern ULO arb03(ULO);
extern ULO arb04(ULO);
extern ULO arb05(ULO);
extern ULO arb06(ULO);
extern ULO arb70(ULO);
extern ULO arb71(ULO);
extern ULO arb72(ULO);
extern ULO arb73(ULO);
extern ULO arb74(ULO);

extern ULO arw00(ULO);
extern ULO arw01(ULO);
extern ULO arw02(ULO);
extern ULO arw03(ULO);
extern ULO arw04(ULO);
extern ULO arw05(ULO);
extern ULO arw06(ULO);
extern ULO arw70(ULO);
extern ULO arw71(ULO);
extern ULO arw72(ULO);
extern ULO arw73(ULO);
extern ULO arw74(ULO);

extern ULO arl00(ULO);
extern ULO arl01(ULO);
extern ULO arl02(ULO);
extern ULO arl03(ULO);
extern ULO arl04(ULO);
extern ULO arl05(ULO);
extern ULO arl06(ULO);
extern ULO arl70(ULO);
extern ULO arl71(ULO);
extern ULO arl72(ULO);
extern ULO arl73(ULO);
extern ULO arl74(ULO);

extern ULO awb00(ULO,ULO);
extern ULO awb02(ULO,ULO);
extern ULO awb03(ULO,ULO);
extern ULO awb04(ULO,ULO);
extern ULO awb05(ULO,ULO);
extern ULO awb06(ULO,ULO);
extern ULO awb70(ULO,ULO);
extern ULO awb71(ULO,ULO);

extern ULO aww00(ULO,ULO);
extern ULO aww01(ULO,ULO);
extern ULO aww02(ULO,ULO);
extern ULO aww03(ULO,ULO);
extern ULO aww04(ULO,ULO);
extern ULO aww05(ULO,ULO);
extern ULO aww06(ULO,ULO);
extern ULO aww70(ULO,ULO);
extern ULO aww71(ULO,ULO);

extern ULO awl00(ULO,ULO);
extern ULO awl01(ULO,ULO);
extern ULO awl02(ULO,ULO);
extern ULO awl03(ULO,ULO);
extern ULO awl04(ULO,ULO);
extern ULO awl05(ULO,ULO);
extern ULO awl06(ULO,ULO);
extern ULO awl70(ULO,ULO);
extern ULO awl71(ULO,ULO);


extern ULO parb03(ULO);
extern ULO parb04(ULO);
extern ULO parb05(ULO);
extern ULO parb06(ULO);
extern ULO parb70(ULO);
extern ULO parb71(ULO);
extern ULO parb72(ULO);
extern ULO parb73(ULO);
extern ULO parb74(ULO);

extern ULO parw03(ULO);
extern ULO parw04(ULO);
extern ULO parw05(ULO);
extern ULO parw06(ULO);
extern ULO parw70(ULO);
extern ULO parw71(ULO);
extern ULO parw72(ULO);
extern ULO parw73(ULO);
extern ULO parw74(ULO);

extern ULO parl03(ULO);
extern ULO parl04(ULO);
extern ULO parl05(ULO);
extern ULO parl06(ULO);
extern ULO parl70(ULO);
extern ULO parl71(ULO);
extern ULO parl72(ULO);
extern ULO parl73(ULO);
extern ULO parl74(ULO);

extern ULO eac02(ULO);
extern ULO eac05(ULO);
extern ULO eac06(ULO);
extern ULO eac70(ULO);
extern ULO eac71(ULO);
extern ULO eac72(ULO);
extern ULO eac73(ULO);
