// Global constants and data from ac.c

#define NROFMODES 7

/* Defines, some must be set also in include\asm\defs.inc */


// Probably broken, but would have enabled cycle exact "blank" lines.
//#define CYCLE_EXACT

// Probably broken, too.  
//#define USE_C

//#define DEFS

// Will remember the last 512000 instructions
// and enable event logging
//#define DEBUGBUILD

// Enable 68000 prefetch emulation for improved compatibility
//#define PREFETCH

// Broken
//#define TSC_PROFILING

#define CHIPMEM 0x200000
#define FASTMEM 0x800000
#define BOGOMEM 0x1c0000
#define KICKMEM 0x080000

#define UBY unsigned char
#define UWO unsigned short int
#define ULO unsigned long
#define BYT signed char
#define WOR signed short int
#define LON signed long
#define FALSE 0
#define TRUE 1

typedef ULO amigaadress;
typedef ULO (*readfunc)();
typedef void (*writefunc)();
typedef ULO (*ciareadfunc)();
typedef void (*ciawritefunc)();
typedef ULO (*regreadfunc)();
typedef void (*regwritefunc)();

/*------------------------------------*/
/* The decode routines have this type */
/*------------------------------------*/

typedef void (*decoderoutinetype)(ULO,ULO);

extern UBY configromname[];

void irq_off(void);
void irq_on(void);
#pragma aux irq_off="cli";
#pragma aux irq_on="sti";

typedef union {
          ULO *lptr;
          UWO *wptr;
          UBY *bptr;
          ULO lval;
          UWO wval[2];
          UBY bval[4];
          } ptunion;

#define LORES 1
#define HIRES 2

typedef void (*planar2chunkyroutine)(void);

typedef void (*add_sample_to_buffer_routine)(ULO amount);
typedef ULO (*setup_soundmode_routine)(void);
typedef void (*playbuffer_routine)(void);
typedef void (*sound_before_emu_routine)(void);
typedef void (*sound_after_emu_routine)(void);

typedef void (*draw_routine_ptr)(void);

typedef ULO (*eareadfunc)(ULO);
typedef void (*eawritefunc)(ULO,ULO);
typedef ULO (*eacalcfunc)(ULO);


void push_ad(void);
void pop_ad(void);
#pragma aux push_ad="pushad";
#pragma aux pop_ad="popad";

void push_eax(void);
void pop_eax(void);
#pragma aux push_eax="push eax";
#pragma aux pop_eax="pop eax";

void push_ecx(void);
void pop_ecx(void);
#pragma aux push_ecx="push ecx";
#pragma aux pop_ecx="pop ecx";


#ifdef TSC_PROFILING
extern __int64 total_tsc;
extern ULO total_tsctimes;
extern __int64 drawptr_tsc;
extern __int64 drawbgline800_tsc;
extern __int64 drawbgline800notdrawn_tsc;
extern __int64 drawlores800_tsc;
extern ULO drawptr_tsctimes;
extern ULO drawbgline800_tsctimes;
extern ULO drawbgline800notdrawn_tsctimes;
extern ULO drawlores800_tsctimes;
extern __int64 drawhires800_tsc;
extern ULO drawhires800_tsctimes;
extern __int64 decodehi2_tsc;
extern ULO decodehi2_tsctimes;
#endif
