/****************************************************************************
 MEMORY RELATED FUNCTIONS
 ****************************************************************************/
/* Functions implemented in ma.asm */

/* TOP LEVEL INTERFACE */
extern ULO fetb(amigaadress ea);
extern ULO fetw(amigaadress ea);
extern ULO fetl(amigaadress ea);
extern void wrib(ULO data, amigaadress ea);
extern void wriw(ULO data, amigaadress ea);
extern void wril(ULO data, amigaadress ea);

/* CHIP RAM INTERFACE */
extern ULO readchipbyte(amigaadress ea);
extern ULO readchipword(amigaadress ea);
extern ULO readchiplong(amigaadress ea);
extern void writechipbyte(ULO data, amigaadress ea);
extern void writechipword(ULO data, amigaadress ea);
extern void writechiplong(ULO data, amigaadress ea);

/* FAST RAM INTERFACE */
extern ULO readfastbyte(amigaadress ea);
extern ULO readfastword(amigaadress ea);
extern ULO readfastlong(amigaadress ea);
extern void writefastbyte(ULO data, amigaadress ea);
extern void writefastword(ULO data, amigaadress ea);
extern void writefastlong(ULO data, amigaadress ea);

/* BOGO RAM INTERFACE */
extern ULO readbogobyte(amigaadress ea);
extern ULO readbogoword(amigaadress ea);
extern ULO readbogolong(amigaadress ea);
extern void writebogobyte(ULO data, amigaadress ea);
extern void writebogoword(ULO data, amigaadress ea);
extern void writebogolong(ULO data, amigaadress ea);

/* KICK ROM INTERFACE */
extern ULO readkickbyte(amigaadress ea);
extern ULO readkickword(amigaadress ea);
extern ULO readkicklong(amigaadress ea);
extern void writekickbyte(ULO data, amigaadress ea);
extern void writekickword(ULO data, amigaadress ea);
extern void writekicklong(ULO data, amigaadress ea);

/* IO REGISTER INTERFACE */
extern ULO readregisterbyte(amigaadress ea);
extern ULO readregisterword(amigaadress ea);
extern ULO readregisterlong(amigaadress ea);
extern void writeregisterbyte(ULO data, amigaadress ea);
extern void writeregisterword(ULO data, amigaadress ea);
extern void writeregisterlong(ULO data, amigaadress ea);

/* CIA INTERFACE */
extern ULO readciabyte(amigaadress ea);
extern ULO readciaword(amigaadress ea);
extern ULO readcialong(amigaadress ea);
extern void writeciabyte(ULO data, amigaadress ea);
extern void writeciaword(ULO data, amigaadress ea);
extern void writecialong(ULO data, amigaadress ea);

/* NOT AVAILABLE INTERFACE */
extern ULO readnotavailablebyte(amigaadress ea);
extern ULO readnotavailableword(amigaadress ea);
extern ULO readnotavailablelong(amigaadress ea);
extern void writenotavailablebyte(ULO data, amigaadress ea);
extern void writenotavailableword(ULO data, amigaadress ea);
extern void writenotavailablelong(ULO data, amigaadress ea);

extern void oddwrite(ULO data,amigaadress ea);
extern ULO oddread(amigaadress ea);

extern ULO wvpos();
extern ULO rid();
extern ULO rciaapra();
extern void wciaapra();
extern ULO rciaaprb();
extern void wciaaprb();
extern ULO rciaaddra();
extern void wciaaddra();
extern ULO rciaaddrb();
extern void wciaaddrb();
extern ULO rciaasp();
extern void wciaasp();
extern ULO rciaatalo();
extern void wciaatalo();
extern ULO rciaatahi();
extern void wciaatahi();
extern ULO rciaatblo();
extern void wciaatblo();
extern ULO rciaatbhi();
extern void wciaatbhi();
extern ULO rciaaevlo();
extern ULO rciaaevmi();
extern ULO rciaaevhi();
extern void wciaaevlo();
extern void wciaaevmi();
extern void wciaaevhi();
extern ULO rciaaicr();
extern void wciaaicr();
extern ULO rciaacra();
extern void wciaacra();
extern ULO rciaacrb();
extern void wciaacrb();
extern ULO rcianothing();
extern void wcianothing();
extern ULO rciabpra();
extern void wciabpra();
extern ULO rciabprb();
extern void wciabprb();
extern ULO rciabddra();
extern void wciabddra();
extern ULO rciabddrb();
extern void wciabddrb();
extern ULO rciabsp();
extern void wciabsp();
extern ULO rciabtalo();
extern void wciabtalo();
extern ULO rciabtahi();
extern void wciabtahi();
extern ULO rciabtblo();
extern void wciabtblo();
extern ULO rciabtbhi();
extern void wciabtbhi();
extern ULO rciabevlo();
extern ULO rciabevmi();
extern ULO rciabevhi();
extern void wciabevlo();
extern void wciabevmi();
extern void wciabevhi();
extern ULO rciabicr();
extern void wciabicr();
extern ULO rciabcra();
extern void wciabcra();
extern ULO rciabcrb();
extern void wciabcrb();



extern ULO rdmaconr();
extern ULO rvposr();
extern ULO rvhposr();
extern ULO rjoy0dat();
extern ULO rjoy1dat();
extern ULO rpot0dat();
extern ULO rpot1dat();
extern ULO rpotgor();
extern ULO rdskbytr();
extern ULO rintenar();
extern ULO rintreqr();
extern ULO rdefault();
extern void wdskpth();
extern void wdskptl();
extern void wdsklen();
extern void wcopcon();
extern void wbltcon0();
extern void wbltcon1();
extern void wbltafwm();
extern void wbltalwm();
extern void wbltcpth();
extern void wbltcptl();
extern void wbltbpth();
extern void wbltbptl();
extern void wbltapth();
extern void wbltaptl();
extern void wbltdpth();
extern void wbltdptl();
extern void wbltsize();
extern void wbltcmod();
extern void wbltbmod();
extern void wbltamod();
extern void wbltdmod();
extern void wbltcdat();
extern void wbltbdat();
extern void wbltadat();
extern void wdsksync();
extern void wcop1lch();
extern void wcop1lcl();
extern void wcop2lch();
extern void wcop2lcl();
extern void wcopjmp1();
extern void wcopjmp2();
extern void wdiwstrt();
extern void wdiwstop();
extern void wddfstrt();
extern void wddfstop();
extern void wdmacon();
extern void wintena();
extern void wintreq();
extern void wadcon();
extern void waud0pth();
extern void waud0ptl();
extern void waud0vol();
extern void waud0len();
extern void waud0per();
extern void waud1pth();
extern void waud1ptl();
extern void waud1vol();
extern void waud1len();
extern void waud1per();
extern void waud2pth();
extern void waud2ptl();
extern void waud2vol();
extern void waud2len();
extern void waud2per();
extern void waud3pth();
extern void waud3ptl();
extern void waud3vol();
extern void waud3len();
extern void waud3per();
extern void wbpl1ptl();
extern void wbpl1pth();
extern void wbpl1ptl();
extern void wbpl2pth();
extern void wbpl2ptl();
extern void wbpl3pth();
extern void wbpl3ptl();
extern void wbpl4pth();
extern void wbpl4ptl();
extern void wbpl5pth();
extern void wbpl5ptl();
extern void wbpl6pth();
extern void wbpl6ptl();
extern void wbplcon0();
extern void wbplcon1();
extern void wbplcon2();
extern void wbpl1mod();
extern void wbpl2mod();
extern void wspr0pth();
extern void wspr0ptl();
extern void wspr1pth();
extern void wspr1ptl();
extern void wspr2pth();
extern void wspr2ptl();
extern void wspr3pth();
extern void wspr3ptl();
extern void wspr4pth();
extern void wspr4ptl();
extern void wspr5pth();
extern void wspr5ptl();
extern void wspr6pth();
extern void wspr6ptl();
extern void wspr7pth();
extern void wspr7ptl();
extern void wdefault();
extern void wcolor();

#ifdef CYCLE_EXACT
extern void wcolorcycleexact();
#endif

extern ULO wriorgadr;


