        .586p
DGROUP group _DATA,_BSS
_TEXT  segment dword public use32 'CODE'
       assume cs:_TEXT, ds:DGROUP, ss:DGROUP

; 68030 emulation for Fellow Amiga Emulator
; Roman 

include defs.inc
include func\memory.inc
include func\68000.inc

include mac\memory.mac

public i301_M_                  ; X
public i301_R_                  ; X
public i302_M_                  ; X
public i302_R_                  ; X
public i303_M_                  ; X
public i303_R_                  ; X
public i304_M_                  ; X
public i304_R_                  ; X
public i305_M_                  ; X
public i305_R_                  ; X
public i306_M_                  ; X
public i306_R_                  ; X
public i307_M_                  ; X
public i307_R_                  ; X
public i308_M_                  ; X
public i308_R_                  ; X
public i309_B_                  ; X
public i309_W_                  ; X
public i309_L_                  ; X
public i310_W_                  ; X
public i310_L_                  ; X
public i311_                    ; X
public i312_B_                  ; X
public i312_W_                  ; X
public i312_L_                  ; X
public i313_W_                  ; X
public i313_L_                  ; X
public i314_                    ; X
public i315_                    ; X
public i316_                    ; X
public i317_                    ; X
public i318_                    ; X
public i319_                    ; X
public i320_                    ; X
public i321_                    ; X
public i322_                    ; X
public i323_                    ; X
public i324_W_                  ; X
public i324_R_                  ; X
public i325_B_                  ; X
public i325_W_                  ; X
public i325_L_                  ; X
public i326_                    ; X
public i327_                    ; X
public i328_                    ; X
public i329_                    ; X
public i330_                    ; X
public i331_                    ; X

public arb063_, arw063_, arl063_
public awb063_, aww063_, awl063_
public parb063_, parw063_, parl063_
public eac063_



;
; Adressmode routines for reading byte,word,longword
; With PC increase
; Parameters:  In:  edx - pointer to register   esi - current PC position
;             Out:  edx - result                esi - current PC position
;

; disp(Ax,Ri) read (68030 compliant)
; ----------------------------------
; a lot of wasted Pentium cycles (especially for 68030 specific addr modes)

	align   4
arl063_:push    ebx
	mov     ebx,edx
	mov     ecx,esi
        fetchw
	add     esi,2
        test    dh, 1                            ; extended params (68030)
        jnz     arl06l
	movsx   ecx,dl
	add     ecx,dword ptr [ebx]
	mov     ebx,edx
	shr     ebx,10
        and     ebx,03ch
	mov     ebx,dword ptr [_d+ebx]
	test    dh,08h
	jnz     xx1_3
	movsx   ebx,bx
xx1_3:  xchg    dx, cx
	shr     cx, 9
	and     cl, 3
	shl     ebx, cl                          ; Ri index multiply (68030)
	xchg    dx, cx
	add     ecx,ebx
	pop     ebx
	jmp     fetl

arl06l: call    arl06x
        pop     ebx
        jmp     fetl

	align   4
arw063_:push    ebx
	mov     ebx,edx
	mov     ecx,esi
        fetchw
	add     esi,2
        test    dh, 1                            ; extended operands (68030)
        jnz     arl06w
	movsx   ecx,dl
	add     ecx,dword ptr [ebx]
	mov     ebx,edx
	shr     ebx,10
        and     ebx,03ch
	mov     ebx,dword ptr [_d+ebx]          ; Exploit position
	test    dh,08h                          ; Size
	jnz     xx2_3
	movsx   ebx,bx
xx2_3:  xchg    dx, cx
	shr     cx, 9
	and     cl, 3
	shl     ebx, cl                         ; Ri index multiply (68030)
	mov     cx, dx
        add     ecx,ebx
	pop     ebx
	jmp     fetw

arl06w: call    arl06x
        pop     ebx
        jmp     fetw

	align   4
arb063_:push    ebx
	mov     ebx,edx
	mov     ecx,esi                         ; Get word for adressmode
        fetchw
	add     esi,2
        test    dh, 1                           ; extended operands (68030)
        jnz     arl06b
	movsx   ecx,dl                          ; Get displacement
	add     ecx,dword ptr [ebx]             ; Add adress register
	mov     ebx,edx
	shr     ebx,10
        and     ebx,03ch
	mov     ebx,dword ptr [_d+ebx]          ; Exploit position
	test    dh,08h                          ; Size
	jnz     xx3_3
	movsx   ebx,bx
xx3_3:  xchg    dx, cx
	shr     cx, 9
	and     cl, 3
	shl     ebx, cl                         ; Ri index multiply (68030)
	mov     cx, dx
        add     ecx,ebx                         ; Add dataregister
	pop     ebx
	jmp     fetb

arl06b: call    arl06x
        pop     ebx
        jmp     fetb

; extended parameter.. (68030)
; common for all fetch sizes, not too big loose though :-)
;                             (comparing to its size :-(()

arl06x: align   4
        push    eax
        mov     ebx, dword ptr [ebx]    ; get Ax reg
        test    dl, 80h                 ; is base shift available ?
        jnz     xx6l1                   ; no
        mov     al, dl
        and     al, 30h
        cmp     al, 20h
        jb      xx6l1                   ; 1 = no base (0 = INVALID actually!)
        push    edx
        mov     ecx, esi
        je      xx6la1                  ; 2 = 16bit base
        fetchl
        add     esi, 4
        jmp     short xx6la2
xx6la1: fetchw
        add     esi, 2
        movsx   edx, dx
xx6la2: add     ebx, edx
        pop     edx
xx6l1:                                  ; and we're back with (Ax)+base in ebx
        mov     eax, ebx
        xor     ebx, ebx
        test    dl, 40h                 ; are we using Ri at all ?
        jnz     xx6l2                   ; no
        mov     bl, dh
        shr     bl, 2
        and     ebx, 3ch
        mov     ebx, [_d + ebx]         ; get Ri
        test    dh, 8
        jnz     xx6lr1
        movsx   ebx, bx
xx6lr1: mov     cl, dh
        shr     cl, 1
        and     cl, 3
        shl     ebx, cl                 ; multiply index 'Siz' times
xx6l2:                                  ; now: eax=(Ax)+base, ebx=(Ri)
        xchg    ebx, edx
        and     ebx, 7
        mov     ecx, eax                ; decode needs ecx=Ax+base, ebx=Ri
        call    [4*ebx + xx6lis]        ; decode IS field
        pop     eax
        ret

xx6lis  dd      xx6lx0, xx6lx1, xx6lx2, xx6lx3
        dd      xx6lx4, xx6lx5, xx6lx6, xx6lx7

xx6lx4: align   4                       ; IS=4 is actually INVALID OPCODE
xx6lx0: ret                             ; IS=0 indirect addr not used
xx6lx1: align   4
        add     ecx, ebx
        call    fetl
        mov     ecx, edx
        ret
xx6lx2: align   4
        add     ecx, ebx
        call    fetl
        mov     ebx, edx
        mov     ecx, esi
        fetchw
        add     esi, 2
        movsx   ecx, dx
        add     ecx, ebx
        ret
xx6lx3: align   4
        add     ecx, ebx
        call    fetl
        mov     ebx, edx
        mov     ecx, esi
        fetchl
        add     esi, 4
        mov     ecx, edx
        add     ecx, ebx
        ret
xx6lx5: align   4
        call    fetl
        mov     ecx, ebx
        add     ecx, edx
        ret
xx6lx6: align   4
        call    fetl
        add     ebx, edx
        mov     ecx, esi
        fetchw
        add     esi, 2
        movsx   ecx, dx
        add     ecx, ebx
        ret
xx6lx7: align   4
        call    fetl
        add     ebx, edx
        mov     ecx, esi
        fetchl
        add     esi, 4
        mov     ecx, edx
        add     ecx, ebx
        ret


;
; Adressmode routines for reading byte,word,longword
; (NOTE!) _Without_ PC increase, without An inc/dec
; Parameters:  In:  edx - pointer to register   esi - current PC position
;             Out:  edx - result                esi - current PC position
;

; disp(Ax,Ri) read (68030 compliant)
; ----------------------------------
; a lot of wasted Pentium cycles (especially for 68030 specific addr modes)

	align   4
parl063_:push    ebx
	mov     ebx,edx
	mov     ecx,esi
        fetchw
        test    dh, 1                            ; extended params (68030)
        jnz     parl06l
	movsx   ecx,dl
	add     ecx,dword ptr [ebx]
	mov     ebx,edx
	shr     ebx,10
        and     ebx,03ch
	mov     ebx,dword ptr [_d+ebx]
	test    dh,08h
	jnz     pxx1_3
	movsx   ebx,bx
pxx1_3: xchg    dx, cx
	shr     cx, 9
	and     cl, 3
	shl     ebx, cl                          ; Ri index multiply (68030)
	xchg    dx, cx
	add     ecx,ebx
	pop     ebx
	jmp     fetl

parl06l:call    parl06x
        pop     ebx
        jmp     fetl

	align   4
parw063_:push    ebx
	mov     ebx,edx
	mov     ecx,esi
        fetchw
        test    dh, 1                            ; extended params (68030)
        jnz     parl06w
	movsx   ecx,dl
	add     ecx,dword ptr [ebx]
	mov     ebx,edx
	shr     ebx,10
        and     ebx,03ch
	mov     ebx,dword ptr [_d+ebx]          ; Exploit position
	test    dh,08h                          ; Size
	jnz     pxx2_3
	movsx   ebx,bx
pxx2_3: xchg    dx, cx
	shr     cx, 9
	and     cl, 3
	shl     ebx, cl                         ; Ri index multiply (68030)
	mov     cx, dx
        add     ecx,ebx
	pop     ebx
	jmp     fetw

parl06w:call    parl06x
        pop     ebx
        jmp     fetw

	align   4
parb063_:push    ebx
	mov     ebx,edx
	mov     ecx,esi                         ; Get word for adressmode
        fetchw
        test    dh, 1                           ; extended params (68030)
        jnz     parl06b
	movsx   ecx,dl                          ; Get displacement
	add     ecx,dword ptr [ebx]             ; Add adress register
	mov     ebx,edx
	shr     ebx,10
        and     ebx,03ch
	mov     ebx,dword ptr [_d+ebx]          ; Exploit position
	test    dh,08h                          ; Size
	jnz     pxx3_3
	movsx   ebx,bx
pxx3_3: xchg    dx, cx
	shr     cx, 9
	and     cl, 3
	shl     ebx, cl                         ; Ri index multiply (68030)
	mov     cx, dx
        add     ecx,ebx                         ; Add dataregister
	pop     ebx
	jmp     fetb

parl06b:call    parl06x
        pop     ebx
        jmp     fetb

; extended parameter.. (68030)
; common for all fetch sizes, not too big loose though :-)
;                             (comparing to its size :-(()

parl06x:align   4
        push    eax
        mov     ebx, dword ptr [ebx]    ; get Ax reg
        test    dl, 80h                 ; is base shift available ?
        jnz     pxx6l1                  ; no
        mov     al, dl
        and     al, 30h
        cmp     al, 20h
        jb      pxx6l1                  ; 1 = no base (0 = INVALID actually!)
        push    edx
        mov     ecx, esi
        add     ecx, 2                  ; real position for xtd param
        je      pxx6la1                 ; 2 = 16bit base
        fetchl
        jmp     short pxx6la2
pxx6la1:fetchw
        movsx   edx, dx
pxx6la2:add     ebx, edx
        pop     edx
pxx6l1:                                 ; and we're back with (Ax)+base in ebx
        mov     eax, ebx
        xor     ebx, ebx
        test    dl, 40h                 ; are we using Ri at all ?
        jnz     pxx6l2                  ; no
        mov     bl, dh
        shr     bl, 2
        and     ebx, 3ch
        mov     ebx, [_d + ebx]         ; get Ri
        test    dh, 8
        jnz     pxx6lr1
        movsx   ebx, bx
pxx6lr1:mov     cl, dh
        shr     cl, 1
        and     cl, 3
        shl     ebx, cl                 ; multiply index 'Siz' times
pxx6l2:                                  ; now: eax=(Ax)+base, ebx=(Ri)
        xchg    ebx, edx
        and     ebx, 7
        mov     ecx, eax                ; decode needs ecx=Ax+base, ebx=Ri
        call    [4*ebx + xx6lis]        ; decode IS field
        pop     eax
        ret


;
; Adressmode routines for writing byte,word,longword
; With PC increase
; Parameters:  In:  ebx - pointer to register   esi - current PC position
;                   edx - data
;

; disp(Ax,Ri) write (68030 compliant)
; -----------------------------------
; a lot of wasted Pentium cycles (especially for 68030 specific addr modes)

	align   4
awl063_:push    edx
	mov     ecx,esi
        fetchw
	add     esi,2
        test    dh, 1                            ; extended params (68030)
        jnz     awl06l
	movsx   ecx,dl
	add     ecx,dword ptr [ebx]
	mov     ebx,edx
	shr     ebx,10
        and     ebx,03ch
	mov     ebx,dword ptr [_d+ebx]
	test    dh,08h
	jnz     wxx1_3
	movsx   ebx,bx
wxx1_3: xchg    dx, cx
	shr     cx, 9
	and     cl, 3
	shl     ebx, cl                          ; Ri index multiply (68030)
	xchg    dx, cx
	add     ecx,ebx
	pop     edx
	jmp     wril

awl06l: call    arl06x
        pop     edx
        jmp     wril

	align   4
aww063_:push    edx
	mov     ecx,esi
        fetchw
	add     esi,2
        test    dh, 1                            ; extended params (68030)
        jnz     awl06w
	movsx   ecx,dl
	add     ecx,dword ptr [ebx]
	mov     ebx,edx
	shr     ebx,10
        and     ebx,03ch
	mov     ebx,dword ptr [_d+ebx]          ; Exploit position
	test    dh,08h                          ; Size
	jnz     wxx2_3
	movsx   ebx,bx
wxx2_3: xchg    dx, cx
	shr     cx, 9
	and     cl, 3
	shl     ebx, cl                         ; Ri index multiply (68030)
	mov     cx, dx
        add     ecx,ebx
	pop     edx
	jmp     wriw

awl06w: call    arl06x
        pop     edx
        jmp     wriw

	align   4
awb063_:push    edx
	mov     ecx,esi                         ; Get word for adressmode
        fetchw
	add     esi,2
        test    dh, 1                           ; extended params (68030)
        jnz     awl06b
	movsx   ecx,dl                          ; Get displacement
	add     ecx,dword ptr [ebx]             ; Add adress register
	mov     ebx,edx
	shr     ebx,10
        and     ebx,03ch
	mov     ebx,dword ptr [_d+ebx]          ; Exploit position
	test    dh,08h                          ; Size
	jnz     wxx3_3
	movsx   ebx,bx
wxx3_3: xchg    dx, cx
	shr     cx, 9
	and     cl, 3
	shl     ebx, cl                         ; Ri index multiply (68030)
	mov     cx, dx
        add     ecx,ebx                         ; Add dataregister
	pop     edx
	jmp     wrib

awl06b: call    arl06x
        pop     edx
        jmp     wrib


;
; Adressmode routines for getting effective address
; With PC increase
; Parameters:  In:  edx - pointer to register   esi - current PC position
;             Out:  edx - result                esi - current PC position
;

; disp(Ax,Ri) get <ea> (68030 compliant)
; --------------------------------------
; a lot of wasted Pentium cycles (especially for 68030 specific addr modes)

	align   4
eac063_:push    ebx
	mov     ebx,edx
	mov     ecx,esi
        fetchw
	add     esi,2
        test    dh, 1                            ; extended params (68030)
        jnz     eac06l
	movsx   ecx,dl
	add     ecx,dword ptr [ebx]
	mov     ebx,edx
	shr     ebx,10
        and     ebx,03ch
	mov     ebx,dword ptr [_d+ebx]
	test    dh,08h
	jnz     xxc1_3
	movsx   ebx,bx
xxc1_3: xchg    dx, cx
	shr     cx, 9
	and     cl, 3
	shl     ebx, cl                          ; Ri index multiply (68030)
	xchg    dx, cx
	add     ecx,ebx
        mov     edx, ecx
	pop     ebx
        ret

eac06l: call    arl06x
        mov     edx, ecx
        pop     ebx
        ret

;
;                        68030 specific instructions
;


;
; Instruction BFCHG <ea>{offset:size}
; Table use: 0 - routine, 1 - disasm, 2 - srcreg, 3 - srcproc, 4 - timing
;

i301_M_:                                 ; bitfield in memory
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        push    ebp
        mov     ecx, esi
        fetchw
        add     esi, 2
        mov     bx, dx
        test    bl, 20h
        jz      i301D0
        and     ebx, 7
        shl     bl, 2
        mov     bx, word ptr [_d + ebx]
i301D0: dec     bl
        and     bl, 1fh                 ; ok, we've bl=size-1 now
        mov     cl, bl
        mov     eax, 07fffffffh
        shr     eax, cl                 ; in eax we have mask
        not     eax

        xor     ebp, ebp
        mov     bx, dx
        shr     bx, 6
        and     bl, 3fh
        test    bl, 20h
        jz      i301D1
        and     ebx, 7
        shl     bl, 2
        mov     ebx, [_d + ebx]
        mov     ebp, ebx
        shr     ebp, 3
        and     ebp, 0fffffffch
i301D1:                                 ; this is offset in first dword ->
        mov     edx, [edi + 8]
        call    [edi + 12]
        mov     ecx, edx
        add     ecx, ebp
        call    fetl
        mov     ebp, edx
        add     ecx, 4
        call    fetl
        push    ecx                     ; it's also the destination addr + 4

        mov     cl, bl                  ; length of the shift
        shld    ebx, ebp, cl            ; move 96-bit work area
        shld    ebp, edx, cl
        shl     edx, cl

        and     dword ptr [_sr], 0fffffff0h
        test    ebp, 80000000h
        jz      i301D2
        or      byte ptr [_sr], 8       ; set N according to highest one
i301D2: test    ebp, eax
        jnz     i301D3
        or      byte ptr [_sr], 4       ; set Z according to whole field

i301D3: xor     ebp, eax                ; do the main thing!

        shrd    edx, ebp, cl
        shrd    ebp, ebx, cl
        pop     ecx
        call    wril
        mov     edx, ebp
        sub     ecx, 4
        call    wril
        mov     eax, [edi + 16]
        pop     ebp
        ret

i301_R_:                                 ; bitfield in datareg
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ecx, esi
        fetchw
        add     esi, 2
        mov     bx, dx
        test    bl, 20h
        jz      i301D4
        and     ebx, 7
        shl     bl, 2
        mov     bx, word ptr [_d + ebx]
i301D4: dec     bl
        and     bl, 1fh                 ; ok, we've bl=size-1 now
        mov     cl, bl
        mov     eax, 07fffffffh
        shr     eax, cl                 ; in eax we have mask
        not     eax

        mov     bx, dx
        shr     bx, 6
        test    bl, 20h
        jz      i301D5
        and     ebx, 7
        shl     bl, 2
        mov     bl, byte ptr [_d + ebx]
i301D5: and     bl, 1fh                 ; this is offset in first dword ->

        mov     ecx, [edi + 8]
        mov     edx, [ecx]
        push    ecx                     ; it's also the destination addr + 4

        mov     cl, bl                  ; length of the shift
        shld    ebx, edx, cl            ; move 64-bit work area
        shl     edx, cl

        and     dword ptr [_sr], 0fffffff0h
        test    edx, 80000000h
        jz      i301D6
        or      byte ptr [_sr], 8       ; set N according to highest one
i301D6: test    edx, eax
        jnz     i301D7
        or      byte ptr [_sr], 4       ; set Z according to whole field

i301D7: xor     edx, eax                ; do the main thing!

        shrd    edx, ebx, cl
        pop     ecx
        call    wril
        mov     eax, [edi + 16]
        ret

;
; Instruction BFCLR <ea>{offset:size}
; Table use: 0 - routine, 1 - disasm, 2 - srcreg, 3 - srcproc, 4 - timing
;

i302_M_:                                 ; bitfield in memory
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        push    ebp
        mov     ecx, esi
        fetchw
        add     esi, 2
        mov     bx, dx
        test    bl, 20h
        jz      i302D0
        and     ebx, 7
        shl     bl, 2
        mov     bx, word ptr [_d + ebx]
i302D0: dec     bl
        and     bl, 1fh                 ; ok, we've bl=size-1 now
        mov     cl, bl
        mov     eax, 07fffffffh
        shr     eax, cl                 ; in eax we have mask
        not     eax

        xor     ebp, ebp
        mov     bx, dx
        shr     bx, 6
        and     bl, 3fh
        test    bl, 20h
        jz      i302D1
        and     ebx, 7
        shl     bl, 2
        mov     ebx, [_d + ebx]
        mov     ebp, ebx
        shr     ebp, 3
        and     ebp, 0fffffffch
i302D1:                                 ; this is offset in first dword ->
        mov     edx, [edi + 8]
        call    [edi + 12]
        mov     ecx, edx
        add     ecx, ebp
        call    fetl
        mov     ebp, edx
        add     ecx, 4
        call    fetl
        push    ecx                     ; it's also the destination addr + 4

        mov     cl, bl                  ; length of the shift
        shld    ebx, ebp, cl            ; move 96-bit work area
        shld    ebp, edx, cl
        shl     edx, cl

        and     dword ptr [_sr], 0fffffff0h
        test    ebp, 80000000h
        jz      i302D2
        or      byte ptr [_sr], 8       ; set N according to highest one
i302D2: test    ebp, eax
        jnz     i302D3
        or      byte ptr [_sr], 4       ; set Z according to whole field

i302D3: not     eax
        and     ebp, eax                ; do the main thing!

        shrd    edx, ebp, cl
        shrd    ebp, ebx, cl
        pop     ecx
        call    wril
        mov     edx, ebp
        sub     ecx, 4
        call    wril
        mov     eax, [edi + 16]
        pop     ebp
        ret

i302_R_:                                 ; bitfield in datareg
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ecx, esi
        fetchw
        add     esi, 2
        mov     bx, dx
        test    bl, 20h
        jz      i302D4
        and     ebx, 7
        shl     bl, 2
        mov     bx, word ptr [_d + ebx]
i302D4: dec     bl
        and     bl, 1fh                 ; ok, we've bl=size-1 now
        mov     cl, bl
        mov     eax, 07fffffffh
        shr     eax, cl                 ; in eax we have mask
        not     eax

        mov     bx, dx
        shr     bx, 6
        test    bl, 20h
        jz      i302D5
        and     ebx, 7
        shl     bl, 2
        mov     bl, byte ptr [_d + ebx]
i302D5: and     bl, 1fh                 ; this is offset in first dword ->

        mov     ecx, [edi + 8]
        mov     edx, [ecx]
        push    ecx                     ; it's also the destination addr + 4

        mov     cl, bl                  ; length of the shift
        shld    ebx, edx, cl            ; move 64-bit work area
        shl     edx, cl

        and     dword ptr [_sr], 0fffffff0h
        test    edx, 80000000h
        jz      i302D6
        or      byte ptr [_sr], 8       ; set N according to highest one
i302D6: test    edx, eax
        jnz     i302D7
        or      byte ptr [_sr], 4       ; set Z according to whole field

i302D7: not     eax
        and     edx, eax                ; do the main thing!

        shrd    edx, ebx, cl
        pop     ecx
        call    wril
        mov     eax, [edi + 16]
        ret

;
; Instruction BFEXTS <ea>{offset:size},Dn
; Table use: 0 - routine, 1 - disasm, 2 - srcreg, 3 - srcproc, 4 - timing
;

i303_M_:                                 ; bitfield in memory
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        push    ebp
        mov     ecx, esi
        fetchw
        add     esi, 2
        push    edx
        mov     bx, dx
        test    bl, 20h
        jz      i303D0
        and     ebx, 7
        shl     bl, 2
        mov     bx, word ptr [_d + ebx]
i303D0: dec     bl
        and     bl, 1fh                 ; ok, we've bl=size-1 now
        mov     cl, bl
        mov     eax, 07fffffffh
        shr     eax, cl                 ; in eax we have mask
        push    ebx                     ; let's save size count - 1
        not     eax

        xor     ebp, ebp
        mov     bx, dx
        shr     bx, 6
        and     bl, 3fh
        test    bl, 20h
        jz      i303D1
        and     ebx, 7
        shl     bl, 2
        mov     ebx, [_d + ebx]
        mov     ebp, ebx
        shr     ebp, 3
        and     ebp, 0fffffffch
i303D1:                                 ; this is offset in first dword ->
        mov     edx, [edi + 8]
        call    [edi + 12]
        mov     ecx, edx
        add     ecx, ebp
        call    fetl
        mov     ebp, edx
        add     ecx, 4
        call    fetl

        mov     cl, bl                  ; length of the shift
        shld    ebp, edx, cl            ; move 64-bit work area

        and     dword ptr [_sr], 0fffffff0h
        test    ebp, 80000000h
        jz      i303D2
        or      byte ptr [_sr], 8       ; set N according to highest one
i303D2: test    ebp, eax
        jnz     i303D3
        or      byte ptr [_sr], 4       ; set Z according to whole field

i303D3: mov     eax, ebp
        cdq
        pop     ecx
        xor     cl, 1fh
        shrd    eax, edx, cl
        pop     ebx                     ; destination Dn
        rol     bx, 6
        and     ebx, 3ch
        mov     [_d + ebx], eax
        mov     eax, [edi + 16]
        pop     ebp
        ret

i303_R_:                                 ; bitfield in datareg
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ecx, esi
        fetchw
        add     esi, 2
        push    edx
        mov     bx, dx
        test    bl, 20h
        jz      i303D4
        and     ebx, 7
        shl     bl, 2
        mov     bx, word ptr [_d + ebx]
i303D4: dec     bl
        and     bl, 1fh                 ; ok, we've bl=size-1 now
        mov     cl, bl
        mov     eax, 07fffffffh
        shr     eax, cl                 ; in eax we have mask
        push    ebx
        not     eax

        mov     bx, dx
        shr     bx, 6
        test    bl, 20h
        jz      i303D5
        and     ebx, 7
        shl     bl, 2
        mov     bl, byte ptr [_d + ebx]
i303D5: and     bl, 1fh                 ; this is offset in first dword ->

        mov     ecx, [edi + 8]
        mov     edx, [ecx]

        mov     cl, bl                  ; length of the shift
        shl     edx, cl                 ; move 32-bit data

        and     dword ptr [_sr], 0fffffff0h
        test    edx, 80000000h
        jz      i303D6
        or      byte ptr [_sr], 8       ; set N according to highest one
i303D6: test    edx, eax
        jnz     i303D7
        or      byte ptr [_sr], 4       ; set Z according to whole field

i303D7: mov     eax, edx
        cdq
        pop     ecx
        xor     cl, 1fh
        shrd    eax, edx, cl
        pop     ebx                     ; destination Dn
        rol     bx, 6
        and     ebx, 3ch
        mov     [_d + ebx], eax
        mov     eax, [edi + 16]
        ret

;
; Instruction BFEXTU <ea>{offset:size},Dn
; Table use: 0 - routine, 1 - disasm, 2 - srcreg, 3 - srcproc, 4 - timing
;

i304_M_:                                 ; bitfield in memory
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        push    ebp
        mov     ecx, esi
        fetchw
        add     esi, 2
        push    edx
        mov     bx, dx
        test    bl, 20h
        jz      i304D0
        and     ebx, 7
        shl     bl, 2
        mov     bx, word ptr [_d + ebx]
i304D0: dec     bl
        and     bl, 1fh                 ; ok, we've bl=size-1 now
        mov     cl, bl
        mov     eax, 07fffffffh
        shr     eax, cl                 ; in eax we have mask
        push    ebx                     ; let's save size count - 1
        not     eax

        xor     ebp, ebp
        mov     bx, dx
        shr     bx, 6
        and     bl, 3fh
        test    bl, 20h
        jz      i304D1
        and     ebx, 7
        shl     bl, 2
        mov     ebx, [_d + ebx]
        mov     ebp, ebx
        shr     ebp, 3
        and     ebp, 0fffffffch
i304D1:                                 ; this is offset in first dword ->
        mov     edx, [edi + 8]
        call    [edi + 12]
        mov     ecx, edx
        add     ecx, ebp
        call    fetl
        mov     ebp, edx
        add     ecx, 4
        call    fetl

        mov     cl, bl                  ; length of the shift
        shld    ebp, edx, cl            ; move 64-bit work area

        and     dword ptr [_sr], 0fffffff0h
        test    ebp, 80000000h
        jz      i304D2
        or      byte ptr [_sr], 8       ; set N according to highest one
i304D2: test    ebp, eax
        jnz     i304D3
        or      byte ptr [_sr], 4       ; set Z according to whole field

i304D3: pop     ecx
        xor     cl, 1fh
        shr     ebp, cl
        pop     ebx                     ; destination Dn
        rol     bx, 6
        and     ebx, 3ch
        mov     [_d + ebx], eax
        mov     eax, [edi + 16]
        pop     ebp
        ret

i304_R_:                                 ; bitfield in datareg
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ecx, esi
        fetchw
        add     esi, 2
        push    edx
        mov     bx, dx
        test    bl, 20h
        jz      i304D4
        and     ebx, 7
        shl     bl, 2
        mov     bx, word ptr [_d + ebx]
i304D4: dec     bl
        and     bl, 1fh                 ; ok, we've bl=size-1 now
        mov     cl, bl
        mov     eax, 07fffffffh
        shr     eax, cl                 ; in eax we have mask
        push    ebx
        not     eax

        mov     bx, dx
        shr     bx, 6
        test    bl, 20h
        jz      i304D5
        and     ebx, 7
        shl     bl, 2
        mov     bl, byte ptr [_d + ebx]
i304D5: and     bl, 1fh                 ; this is offset in first dword ->

        mov     ecx, [edi + 8]
        mov     edx, [ecx]

        mov     cl, bl                  ; length of the shift
        shl     edx, cl                 ; move 32-bit data

        and     dword ptr [_sr], 0fffffff0h
        test    edx, 80000000h
        jz      i304D6
        or      byte ptr [_sr], 8       ; set N according to highest one
i304D6: test    edx, eax
        jnz     i304D7
        or      byte ptr [_sr], 4       ; set Z according to whole field

i304D7: pop     ecx
        xor     cl, 1fh
        shr     edx, cl
        pop     ebx                     ; destination Dn
        rol     bx, 6
        and     ebx, 3ch
        mov     [_d + ebx], eax
        mov     eax, [edi + 16]
        ret

;
; Instruction BFFFO <ea>{offset:size},Dn
; Table use: 0 - routine, 1 - disasm, 2 - srcreg, 3 - srcproc, 4 - timing
;

i305_M_:                                 ; bitfield in memory
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        push    ebp
        mov     ecx, esi
        fetchw
        add     esi, 2
        push    edx
        mov     bx, dx
        test    bl, 20h
        jz      i305D0
        and     ebx, 7
        shl     bl, 2
        mov     bx, word ptr [_d + ebx]
i305D0: dec     bl
        and     bl, 1fh                 ; ok, we've bl=size-1 now
        mov     cl, bl
        mov     eax, 07fffffffh
        shr     eax, cl                 ; in eax we have mask
        not     eax

        xor     ebp, ebp
        movzx   ebx, dx
        shr     bx, 6
        and     bl, 3fh
        test    bl, 20h
        jz      i305D1
        and     ebx, 7
        shl     bl, 2
        mov     ebx, [_d + ebx]
        mov     ebp, ebx
        shr     ebp, 3
        and     ebp, 0fffffffch
i305D1:                                 ; this is offset in first dword ->
        mov     edx, [edi + 8]
        call    [edi + 12]
        mov     ecx, edx
        add     ecx, ebp
        call    fetl
        mov     ebp, edx
        add     ecx, 4
        call    fetl

        mov     ecx, ebx                ; length of the shift
        shld    ebp, edx, cl            ; move 64-bit work area

        and     dword ptr [_sr], 0fffffff0h
        test    ebp, 80000000h
        jz      i305D2
        or      byte ptr [_sr], 8       ; set N according to highest one
i305D2: and     ebp, eax
        jnz     i305D3
        or      byte ptr [_sr], 4       ; set Z according to whole field

i305D3: bsr     ebx, ebp                ; scan reverse for bit offset
        jz      i305D30                 ; found any ?
        bsf     ebx, eax                ; get first
i305D30:xor     bl, 1fh
        add     ecx, ebx                ; original offset + found pos
        pop     ebx                     ; destination Dn
        rol     bx, 6
        and     ebx, 3ch
        mov     [_d + ebx], ecx
        mov     eax, [edi + 16]
        pop     ebp
        ret

i305_R_:                                 ; bitfield in datareg
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ecx, esi
        fetchw
        add     esi, 2
        push    edx
        mov     bx, dx
        test    bl, 20h
        jz      i305D4
        and     ebx, 7
        shl     bl, 2
        mov     bx, word ptr [_d + ebx]
i305D4: dec     bl
        and     bl, 1fh                 ; ok, we've bl=size-1 now
        mov     cl, bl
        mov     eax, 07fffffffh
        shr     eax, cl                 ; in eax we have mask
        push    ebx
        not     eax

        mov     bx, dx
        shr     bx, 6
        test    bl, 20h
        jz      i305D5
        and     ebx, 7
        shl     bl, 2
        mov     bl, byte ptr [_d + ebx]
i305D5: and     bl, 1fh                 ; this is offset in first dword ->

        mov     ecx, [edi + 8]
        mov     edx, [ecx]

        mov     ecx, ebx                ; length of the shift
        shl     edx, cl                 ; move 32-bit data

        and     dword ptr [_sr], 0fffffff0h
        test    edx, 80000000h
        jz      i305D6
        or      byte ptr [_sr], 8       ; set N according to highest one
i305D6: test    edx, eax
        jnz     i305D7
        or      byte ptr [_sr], 4       ; set Z according to whole field

i305D7: bsr     ebx, edx                ; scan reverse for bit offset
        jz      i305D70                 ; found any ?
        bsf     ebx, eax                ; get first
i305D70:xor     bl, 1fh
        add     ecx, ebx                ; original offset + found pos
        pop     ebx                     ; destination Dn
        rol     bx, 6
        and     ebx, 3ch
        mov     [_d + ebx], ecx
        mov     eax, [edi + 16]
        ret

;
; Instruction BFINS Dn,<ea>{offset:size}
; Table use: 0 - routine, 1 - disasm, 2 - dstreg, 3 - dstproc, 4 - timing
;

i306_M_:                                 ; bitfield in memory
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        push    ebp
        mov     ecx, esi
        fetchw
        add     esi, 2
        push    edx
        mov     bx, dx
        test    bl, 20h
        jz      i306D0
        and     ebx, 7
        shl     bl, 2
        mov     bx, word ptr [_d + ebx]
i306D0: dec     bl
        and     bl, 1fh                 ; ok, we've bl=size-1 now
        mov     cl, bl
        mov     eax, 07fffffffh
        shr     eax, cl                 ; in eax we have mask
        push    ebx                     ; store size-1 on the stack
        not     eax

        xor     ebp, ebp
        mov     bx, dx
        shr     bx, 6
        and     bl, 3fh
        test    bl, 20h
        jz      i306D1
        and     ebx, 7
        shl     bl, 2
        mov     ebx, [_d + ebx]
        mov     ebp, ebx
        shr     ebp, 3
        and     ebp, 0fffffffch
i306D1:                                 ; this is offset in first dword ->
        mov     edx, [edi + 8]
        call    [edi + 12]
        mov     ecx, edx
        add     ecx, ebp
        call    fetl
        mov     ebp, edx
        add     ecx, 4
        call    fetl
        push    ecx                     ; it's also the destination addr + 4

        mov     cl, bl                  ; length of the shift
        shld    ebx, ebp, cl            ; move 96-bit work area
        shld    ebp, edx, cl
        shl     edx, cl

        not     eax
        and     ebp, eax                ; clear bitfield area

        push    ebx                     ; !!when added another, xchg index!!
        push    ecx                     ;                                |
        mov     ebx, esp                ;                                |
        mov     ecx, ss:[ebx + 12]      ; this gets size-1 from stack  <-'
        mov     ebx, ss:[ebx + 16]      ; this gets Dn from stack
        rol     bx, 6
        and     ebx, 3ch
        mov     ebx, [_d + ebx]         ; get real Dn
        xor     cl, 1fh
        shl     ebx, cl
        or      ebp, ebx                ; this inserts new bits in bitfield
        pop     ecx
        pop     ebx

        and     dword ptr [_sr], 0fffffff0h
        test    ebp, 80000000h
        jz      i306D2
        or      byte ptr [_sr], 8       ; set N according to highest one
i306D2: not     eax
        test    ebp, eax
        jnz     i306D3
        or      byte ptr [_sr], 4       ; set Z according to whole field

i306D3: shrd    edx, ebp, cl
        shrd    ebp, ebx, cl
        pop     ecx
        call    wril
        mov     edx, ebp
        sub     ecx, 4
        call    wril
        mov     eax, [edi + 16]
        pop     ebx
        pop     ebx
        pop     ebp
        ret

i306_R_:                                 ; bitfield in datareg
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ecx, esi
        fetchw
        add     esi, 2
        push    edx
        mov     bx, dx
        test    bl, 20h
        jz      i306D4
        and     ebx, 7
        shl     bl, 2
        mov     bx, word ptr [_d + ebx]
i306D4: dec     bl
        and     bl, 1fh                 ; ok, we've bl=size-1 now
        mov     cl, bl
        mov     eax, 07fffffffh
        shr     eax, cl                 ; in eax we have mask
        push    ebx                     ; put size-1 on the stack
        not     eax

        mov     bx, dx
        shr     bx, 6
        test    bl, 20h
        jz      i306D5
        and     ebx, 7
        shl     bl, 2
        mov     bl, byte ptr [_d + ebx]
i306D5: and     bl, 1fh                 ; this is offset in first dword ->

        mov     ecx, [edi + 8]
        mov     edx, [ecx]
        push    ecx                     ; it's also the destination addr + 4

        mov     cl, bl                  ; length of the shift
        shld    ebx, edx, cl            ; move 64-bit work area
        shl     edx, cl

        not     eax
        and     edx, eax                ; do the main thing!

        push    ebx
        push    ecx
        mov     ebx, esp
        mov     ecx, ss:[ebx + 16]      ; this gets size-1 from stack!
        mov     ebx, ss:[ebx + 20]      ; get Dn num
        rol     bx, 6
        and     ebx, 3ch
        mov     ebx, [_d + ebx]         ; get real Dn
        xor     cl, 1fh
        shl     ebx, cl
        or      ebp, ebx                ; this inserts new bits in bitfield
        pop     ecx
        pop     ebx

        and     dword ptr [_sr], 0fffffff0h
        test    edx, 80000000h
        jz      i306D6
        or      byte ptr [_sr], 8       ; set N according to highest one
i306D6: not     eax
        test    edx, eax
        jnz     i306D7
        or      byte ptr [_sr], 4       ; set Z according to whole field

i306D7: shrd    edx, ebx, cl
        pop     ecx
        call    wril
        mov     eax, [edi + 16]
        ret

;
; Instruction BFSET <ea>{offset:size}
; Table use: 0 - routine, 1 - disasm, 2 - srcreg, 3 - srcproc, 4 - timing
;

i307_M_:                                 ; bitfield in memory
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        push    ebp
        mov     ecx, esi
        fetchw
        add     esi, 2
        mov     bx, dx
        test    bl, 20h
        jz      i307D0
        and     ebx, 7
        shl     bl, 2
        mov     bx, word ptr [_d + ebx]
i307D0: dec     bl
        and     bl, 1fh                 ; ok, we've bl=size-1 now
        mov     cl, bl
        mov     eax, 07fffffffh
        shr     eax, cl                 ; in eax we have mask
        not     eax

        xor     ebp, ebp
        mov     bx, dx
        shr     bx, 6
        and     bl, 3fh
        test    bl, 20h
        jz      i307D1
        and     ebx, 7
        shl     bl, 2
        mov     ebx, [_d + ebx]
        mov     ebp, ebx
        shr     ebp, 3
        and     ebp, 0fffffffch
i307D1:                                 ; this is offset in first dword ->
        mov     edx, [edi + 8]
        call    [edi + 12]
        mov     ecx, edx
        add     ecx, ebp
        call    fetl
        mov     ebp, edx
        add     ecx, 4
        call    fetl
        push    ecx                     ; it's also the destination addr + 4

        mov     cl, bl                  ; length of the shift
        shld    ebx, ebp, cl            ; move 96-bit work area
        shld    ebp, edx, cl
        shl     edx, cl

        and     dword ptr [_sr], 0fffffff0h
        test    ebp, 80000000h
        jz      i307D2
        or      byte ptr [_sr], 8       ; set N according to highest one
i307D2: test    ebp, eax
        jnz     i307D3
        or      byte ptr [_sr], 4       ; set Z according to whole field

i307D3: or      ebp, eax                ; do the main thing!

        shrd    edx, ebp, cl
        shrd    ebp, ebx, cl
        pop     ecx
        call    wril
        mov     edx, ebp
        sub     ecx, 4
        call    wril
        mov     eax, [edi + 16]
        pop     ebp
        ret

i307_R_:                                 ; bitfield in datareg
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ecx, esi
        fetchw
        add     esi, 2
        mov     bx, dx
        test    bl, 20h
        jz      i307D4
        and     ebx, 7
        shl     bl, 2
        mov     bx, word ptr [_d + ebx]
i307D4: dec     bl
        and     bl, 1fh                 ; ok, we've bl=size-1 now
        mov     cl, bl
        mov     eax, 07fffffffh
        shr     eax, cl                 ; in eax we have mask
        not     eax

        mov     bx, dx
        shr     bx, 6
        test    bl, 20h
        jz      i307D5
        and     ebx, 7
        shl     bl, 2
        mov     bl, byte ptr [_d + ebx]
i307D5: and     bl, 1fh                 ; this is offset in first dword ->

        mov     ecx, [edi + 8]
        mov     edx, [ecx]
        push    ecx                     ; it's also the destination addr + 4

        mov     cl, bl                  ; length of the shift
        shld    ebx, edx, cl            ; move 64-bit work area
        shl     edx, cl

        and     dword ptr [_sr], 0fffffff0h
        test    edx, 80000000h
        jz      i307D6
        or      byte ptr [_sr], 8       ; set N according to highest one
i307D6: test    edx, eax
        jnz     i307D7
        or      byte ptr [_sr], 4       ; set Z according to whole field

i307D7: or      edx, eax                ; do the main thing!

        shrd    edx, ebx, cl
        pop     ecx
        call    wril
        mov     eax, [edi + 16]
        ret

;
; Instruction BFTST <ea>{offset:size}
; Table use: 0 - routine, 1 - disasm, 2 - srcreg, 3 - srcproc, 4 - timing
;

i308_M_:                                 ; bitfield in memory
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        push    ebp
        mov     ecx, esi
        fetchw
        add     esi, 2
        mov     bx, dx
        test    bl, 20h
        jz      i308D0
        and     ebx, 7
        shl     bl, 2
        mov     bx, word ptr [_d + ebx]
i308D0: dec     bl
        and     bl, 1fh                 ; ok, we've bl=size-1 now
        mov     cl, bl
        mov     eax, 07fffffffh
        shr     eax, cl                 ; in eax we have mask
        not     eax

        xor     ebp, ebp
        mov     bx, dx
        shr     bx, 6
        and     bl, 3fh
        test    bl, 20h
        jz      i308D1
        and     ebx, 7
        shl     bl, 2
        mov     ebx, [_d + ebx]
        mov     ebp, ebx
        shr     ebp, 3
        and     ebp, 0fffffffch
i308D1:                                 ; this is offset in first dword ->
        mov     edx, [edi + 8]
        call    [edi + 12]
        mov     ecx, edx
        add     ecx, ebp
        call    fetl
        mov     ebp, edx
        add     ecx, 4
        call    fetl

        mov     cl, bl                  ; length of the shift
        shld    ebp, edx, cl            ; move 64-bit work area

        and     dword ptr [_sr], 0fffffff0h
        test    ebp, 80000000h
        jz      i308D2
        or      byte ptr [_sr], 8       ; set N according to highest one
i308D2: test    ebp, eax
        jnz     i308D3
        or      byte ptr [_sr], 4       ; set Z according to whole field

i308D3: mov     eax, [edi + 16]
        pop     ebp
        ret

i308_R_:                                 ; bitfield in datareg
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ecx, esi
        fetchw
        add     esi, 2
        mov     bx, dx
        test    bl, 20h
        jz      i308D4
        and     ebx, 7
        shl     bl, 2
        mov     bx, word ptr [_d + ebx]
i308D4: dec     bl
        and     bl, 1fh                 ; ok, we've bl=size-1 now
        mov     cl, bl
        mov     eax, 07fffffffh
        shr     eax, cl                 ; in eax we have mask
        not     eax

        mov     bx, dx
        shr     bx, 6
        test    bl, 20h
        jz      i308D5
        and     ebx, 7
        shl     bl, 2
        mov     bl, byte ptr [_d + ebx]
i308D5: and     bl, 1fh                 ; this is offset in first dword ->

        mov     ecx, [edi + 8]
        mov     edx, [ecx]

        mov     cl, bl                  ; length of the shift
        shl     edx, cl                 ; move 32-bit work area

        and     dword ptr [_sr], 0fffffff0h
        test    edx, 80000000h
        jz      i308D6
        or      byte ptr [_sr], 8       ; set N according to highest one
i308D6: test    edx, eax
        jnz     i308D7
        or      byte ptr [_sr], 4       ; set Z according to whole field

i308D7: mov     eax, [edi + 16]
        ret

;
; Instruction CAS Dc,Du,<ea>                                 (All, not X)
; Table use: 0 - routine, 1 - disasm, 2 - srcreg, 3 - eacproc, 4 - timing
;

i309_B_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     edx, [edi + 8]
        call    [edi + 12]              ; edx = <ea>
        mov     eax, edx
        mov     ecx, esi
        fetchw                          ; get extra word
        add     esi, 2
        push    edx
        mov     bl, dl
        shl     bl, 2
        and     ebx, 1ch
        mov     ebx, [_d + ebx]         ; get Dc
        mov     ecx, eax
        call    fetb
        cmp     bl, dl
	pushfd
	pop     ecx
	and     ecx, 0fffh
	mov     ebx, dword ptr [_statustab+4*ecx]
	mov     ecx, dword ptr _sr
	and     ecx, 0fffffff0h
	and     ebx, 0fh
	or      ecx, ebx
	mov     dword ptr _sr, ecx

        cmp     bl, dl
        jnz     i309_B1

        pop     ebx
        shr     bx, 4
        and     ebx, 1ch
        mov     edx, [_d + ebx]
        mov     ecx, eax
        call    wrib
        mov     eax, [edi + 16]
        ret

i309_B1:pop     ebx
        shl     bl, 2
        and     ebx, 1ch
        mov     byte ptr [_d + ebx], dl
        mov     eax, [edi + 16]
        ret

i309_W_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     edx, [edi + 8]
        call    [edi + 12]              ; edx = <ea>
        mov     eax, edx
        mov     ecx, esi
        fetchw                          ; get extra word
        add     esi, 2
        push    edx
        mov     bl, dl
        shl     bl, 2
        and     ebx, 1ch
        mov     ebx, [_d + ebx]         ; get Dc
        mov     ecx, eax
        call    fetw
        cmp     bx, dx
	pushfd
	pop     ecx
	and     ecx, 0fffh
	mov     ebx, dword ptr [_statustab+4*ecx]
	mov     ecx, dword ptr _sr
	and     ecx, 0fffffff0h
	and     ebx, 0fh
	or      ecx, ebx
	mov     dword ptr _sr, ecx

        cmp     bx, dx
        jnz     i309_W1

        pop     ebx
        shr     bx, 4
        and     ebx, 1ch
        mov     edx, [_d + ebx]
        mov     ecx, eax
        call    wriw
        mov     eax, [edi + 16]
        ret

i309_W1:pop     ebx
        shl     bl, 2
        and     ebx, 1ch
        mov     word ptr [_d + ebx], dx
        mov     eax, [edi + 16]
        ret

i309_L_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     edx, [edi + 8]
        call    [edi + 12]              ; edx = <ea>
        mov     eax, edx
        mov     ecx, esi
        fetchw                          ; get extra word
        add     esi, 2
        push    edx
        mov     bl, dl
        shl     bl, 2
        and     ebx, 1ch
        mov     ebx, [_d + ebx]         ; get Dc
        mov     ecx, eax
        call    fetl
        cmp     ebx, edx
	pushfd
	pop     ecx
	and     ecx, 0fffh
	mov     ebx, dword ptr [_statustab+4*ecx]
	mov     ecx, dword ptr _sr
	and     ecx, 0fffffff0h
	and     ebx, 0fh
	or      ecx, ebx
	mov     dword ptr _sr, ecx

        cmp     ebx, edx
        jnz     i309_L1

        pop     ebx
        shr     bx, 4
        and     ebx, 1ch
        mov     edx, [_d + ebx]
        mov     ecx, eax
        call    wril
        mov     eax, [edi + 16]
        ret

i309_L1:pop     ebx
        shl     bl, 2
        and     ebx, 1ch
        mov     [_d + ebx], edx
        mov     eax, [edi + 16]
        ret

;
; Instruction CAS2 Dc1:Dc2,Du1:Du2,(Rx1):(Rx2)              (All, not X)
; Table use: 0 - routine, 1 - disasm, 2 - timing
;

i310_W_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ecx, esi
        fetchl                          ; get params
        add     esi, 4
        mov     eax, edx
        ror     edx, 16                 ; first we need Dc1/Du1/Rx1
        mov     bx, dx
        rol     bx, 6
        and     ebx, 3ch
        mov     ecx, [_d + ebx]
        call    fetw
        push    edx                     ; data from (Rx1)
        push    ecx                     ; eac from Rx1
        mov     bx, ax
        shl     bx, 2
        and     ebx, 1ch
        cmp     dx, word ptr [_d + ebx] ; Dc1 = Rx1 ?
        jne     i310wn1
        mov     bx, ax
        rol     bx, 6
        and     ebx, 3ch
        mov     ecx, [_d + ebx]
        call    fetw
        mov     bx, ax
        shl     bx, 2
        and     ebx, 1ch
        cmp     dx, word ptr [_d + ebx] ; Dc2 = Rx2 ?
        push    ecx
	pushfd
	pop     ecx
	and     ecx, 0fffh
	mov     ebx, dword ptr [_statustab+4*ecx]
	mov     ecx, dword ptr _sr
	and     ecx, 0fffffff0h
	and     ebx, 0fh
	or      ecx, ebx
	mov     dword ptr _sr, ecx
        pop     ecx
        cmp     dx, word ptr [_d + ebx] ; Dc2 = Rx2 ?
        jne     i310wn2
        mov     bx, ax
        shr     bx, 4
        and     bx, 1ch
        mov     edx, [_d + ebx]
        call    wriw                    ; (Rx2) <- Du2
        pop     ecx
        ror     eax, 16
        mov     bx, ax
        shr     bx, 4
        and     bx, 1ch
        mov     edx, [_d + ebx]
        call    wriw                    ; (Rx1) <- Du1
        pop     edx
        mov     eax, [edi + 8]
        ret

i310wn1:pushfd
	pop     ecx
	and     ecx, 0fffh
	mov     ebx, dword ptr [_statustab+4*ecx]
	mov     ecx, dword ptr _sr
	and     ecx, 0fffffff0h
	and     ebx, 0fh
	or      ecx, ebx
	mov     dword ptr _sr, ecx
i310wn2:pop     ecx                             ; eac Rx1
        pop     edx                             ; (Rx1)
        mov     ebx, eax
        ror     ebx, 20
        and     ebx, 1ch
        mov     word ptr [_d + ebx], dx         ; Dc1 <- (Rx1)
        mov     bx, ax
        rol     bx, 6
        and     ebx, 3ch
        mov     ecx, [_d + ebx]                 ; eac Rx2
        call    fetw
        mov     bx, ax
        rol     bx, 2
        and     ebx, 1ch
        mov     word ptr [_d + ebx], dx         ; Dc2 <- (Rx2)
        mov     eax, [edi + 8]
        ret

i310_L_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ecx, esi
        fetchl                          ; get params
        add     esi, 4
        mov     eax, edx
        ror     edx, 16                 ; first we need Dc1/Du1/Rx1
        mov     bx, dx
        rol     bx, 6
        and     ebx, 3ch
        mov     ecx, [_d + ebx]
        call    fetl
        push    edx                     ; data from (Rx1)
        push    ecx                     ; eac from Rx1
        mov     bx, ax
        shl     bx, 2
        and     ebx, 1ch
        cmp     dx, word ptr [_d + ebx] ; Dc1 = Rx1 ?
        jne     i310ln1
        mov     bx, ax
        rol     bx, 6
        and     ebx, 3ch
        mov     ecx, [_d + ebx]
        call    fetl
        mov     bx, ax
        shl     bx, 2
        and     ebx, 1ch
        cmp     edx, dword ptr [_d + ebx] ; Dc2 = Rx2 ?
        push    ecx
	pushfd
	pop     ecx
	and     ecx, 0fffh
	mov     ebx, dword ptr [_statustab+4*ecx]
	mov     ecx, dword ptr _sr
	and     ecx, 0fffffff0h
	and     ebx, 0fh
	or      ecx, ebx
	mov     dword ptr _sr, ecx
        pop     ecx
        cmp     edx, dword ptr [_d + ebx] ; Dc2 = Rx2 ?
        jne     i310ln2
        mov     bx, ax
        shr     bx, 4
        and     bx, 1ch
        mov     edx, [_d + ebx]
        call    wril                    ; (Rx2) <- Du2
        pop     ecx
        ror     eax, 16
        mov     bx, ax
        shr     bx, 4
        and     bx, 1ch
        mov     edx, [_d + ebx]
        call    wril                    ; (Rx1) <- Du1
        pop     edx
        mov     eax, [edi + 8]
        ret

i310ln1:pushfd
	pop     ecx
	and     ecx, 0fffh
	mov     ebx, dword ptr [_statustab+4*ecx]
	mov     ecx, dword ptr _sr
	and     ecx, 0fffffff0h
	and     ebx, 0fh
	or      ecx, ebx
	mov     dword ptr _sr, ecx
i310ln2:pop     ecx                             ; eac Rx1
        pop     edx                             ; (Rx1)
        mov     ebx, eax
        ror     ebx, 20
        and     ebx, 1ch
        mov     [_d + ebx], edx                 ; Dc1 <- (Rx1)
        mov     bx, ax
        rol     bx, 6
        and     ebx, 3ch
        mov     ecx, [_d + ebx]                 ; eac Rx2
        call    fetl
        mov     bx, ax
        rol     bx, 2
        and     ebx, 1ch
        mov     [_d + ebx], edx                 ; Dc2 <- (Rx2)
        mov     eax, [edi + 8]
        ret

;
; Instruction CHK.L <ea>,Dn
; Table use: 0 - routine, 1 - disasm, 2 - srcreg
;            3 - srcproc, 4 - dstreg, 5 - timing
;

i311_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     eax,dword ptr [edi+12]
	mov     edx,dword ptr [edi+8]
	call    eax
	mov     ebx,dword ptr [edi+16]
	mov     eax,dword ptr [ebx]
	and     dword ptr _sr, 0fffffffbh
	or      eax, eax
	js      i311trapset
	cmp     eax, edx
	ja      i311trap
	mov     eax, dword ptr [edi+20]
	ret
i311TrapSet:
	or      dword ptr _sr, 8
i311Trap:
        mov     ebx,18h                         ; vector at $18
	mov     eax,34
	add     eax,dword ptr [edi+20]
        jmp     prepare_exception_

;
; Instruction CHK2.X <ea>,Rn / CMP2.X <ea>,Rn
; Table use: 0 - routine, 1 - disasm, 2 - srcreg, 3 - srcproc, 4 - timing
;

i312_B_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ecx, esi
        fetchw
        add     esi, 2
        mov     ebx, edx
        rol     bx, 6
        push    ebx
        and     ebx, 3ch
        mov     eax, [_d + ebx]
        push    eax
        mov     eax, dword ptr [edi + 12]
	mov     edx, dword ptr [edi + 8]
	call    eax
        pop     eax
	and     dword ptr _sr, 0fffffffah
        test    bl, 20h
        jnz     i312AddrB
	cmp     al, dl
	jz      i312Zset
        js      i312Cset
        push    eax
        mov     eax, dword ptr [edi + 12]
	mov     edx, dword ptr [edi + 8]
        add     edx, 2
	call    eax
        pop     eax
	cmp     al, dl
	ja      i312CSet
        jnz     i312E
i312ZSet:
        or      dword ptr _sr, 4
i312E:  pop     ebx
i312E2: mov     eax, dword ptr [edi + 20]
	ret
i312CSet:
	or      dword ptr _sr, 1
        pop     ebx
        test    bl, 2                           ; are we doing CHK2 or CMP2 ?
        jz      i312E2
        mov     ebx, 18h                        ; vector at $18
	mov     eax, 34
	add     eax, dword ptr [edi + 20]
        jmp     prepare_exception_

i312AddrB:
        movsx   edx, dl
	cmp     eax, edx
	jz      i312Zset
        js      i312Cset
        push    eax
        mov     eax, dword ptr [edi + 12]
	mov     edx, dword ptr [edi + 8]
        add     edx, 2
	call    eax
        pop     eax
        movsx   edx, dl
	cmp     eax, edx
	ja      i312CSet
        jnz     i312E
        or      dword ptr _sr, 4
        pop     ebx
        mov     eax, dword ptr [edi + 20]
	ret

i312_W_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ecx, esi
        fetchw
        add     esi, 2
        mov     ebx, edx
        rol     bx, 6
        push    ebx
        and     ebx, 3ch
        mov     eax, [_d + ebx]
        push    eax
        mov     eax, dword ptr [edi + 12]
	mov     edx, dword ptr [edi + 8]
	call    eax
        pop     eax
	and     dword ptr _sr, 0fffffffah
        test    bl, 20h
        jnz     i312AddrW
	cmp     ax, dx
	jz      i312Zset
        js      i312Cset
        push    eax
        mov     eax, dword ptr [edi + 12]
	mov     edx, dword ptr [edi + 8]
        add     edx, 2
	call    eax
        pop     eax
	cmp     ax, dx
	ja      i312CSet
        jnz     i312E
        or      dword ptr _sr, 4
        pop     ebx
        mov     eax, dword ptr [edi + 20]
	ret

i312AddrW:
        movsx   edx, dx
	cmp     eax, edx
	jz      i312Zset
        js      i312Cset
        push    eax
        mov     eax, dword ptr [edi + 12]
	mov     edx, dword ptr [edi + 8]
        add     edx, 2
	call    eax
        pop     eax
        movsx   edx, dx
	cmp     eax, edx
	ja      i312CSet
        jnz     i312E
        or      dword ptr _sr, 4
        pop     ebx
        mov     eax, dword ptr [edi + 20]
	ret

i312_L_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ecx, esi
        fetchw
        add     esi, 2
        mov     ebx, edx
        rol     bx, 6
        push    ebx
        and     ebx, 3ch
        mov     eax, [_d + ebx]
        push    eax
        mov     eax, dword ptr [edi + 12]
	mov     edx, dword ptr [edi + 8]
	call    eax
        pop     eax
	and     dword ptr _sr, 0fffffffah
	cmp     eax, edx
	jz      i312Zset
        js      i312Cset
        push    eax
        mov     eax, dword ptr [edi + 12]
	mov     edx, dword ptr [edi + 8]
        add     edx, 2
	call    eax
        pop     eax
	cmp     eax, edx
	ja      i312CSet
        jnz     i312E
        or      dword ptr _sr, 4
        pop     ebx
        mov     eax, dword ptr [edi + 20]
	ret

;
; Instruction cpBcc <label>
; Table use: 0 - routine, 1 - disasm, 2 - coprocessor, 3 - condition
;

i313_W_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        push    dword ptr [edi + 12]            ; prepare condition
        push    offset i313_si                  ; store PC reader
        push    edi                             ; prepare table ptr
        push    esi                             ; prepare current PC
        mov     ebx, [edi + 8]
        shl     ebx, 4                          ; table with 4 procs per copr
        call    [_coproc_tbl + ebx]             ; coprproc0
        pop     esi
        pop     edi
        pop     ecx
        pop     ecx
        movzx   ecx, ax                         ; PC skip in low word
        add     esi, ecx                        ; inc PC (skip copr instrs)
        test    eax, 10000h
        jz      i313_Wn
        mov     ecx, esi
        fetchw
        movsx   edx, dx
        add     esi, edx
i313_Wn:add     esi, 2
        mov     eax, 0
        ret

i313_L_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        push    dword ptr [edi + 12]            ; prepare condition
        push    offset i313_si                  ; store PC reader
        push    edi                             ; prepare table ptr
        push    esi                             ; prepare current PC
        mov     ebx, [edi + 8]
        shl     ebx, 4                          ; table with 4 procs per copr
        call    [_coproc_tbl + ebx]             ; coprproc0
        pop     esi
        pop     edi
        pop     ecx
        pop     ecx
        movzx   ecx, ax                         ; PC skip in low word
        add     esi, ecx                        ; inc PC (skip copr instrs)
        test    eax, 10000h
        jz      i313_Ln                         ; condition not met
        mov     ecx, esi
        fetchl
        add     esi, edx
i313_Ln:add     esi, 4
        mov     eax, 0
        ret

i313_si:push    ebp
        mov     ebp, esp
        mov     ecx, [ebp + 4]
        fetchw
        pop     ebp
        ret

;
; Instruction cpDBcc <label>
; Table use: 0 - routine, 1 - disasm, 2 - coprocessor, 3 - *Dn
;

i314_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ecx, esi
        fetchw
        add     esi, 2
        and     edx, 3fh
        push    edx                             ; prepare condition
        push    offset i313_si                  ; store PC reader
        push    edi                             ; prepare table ptr
        push    esi                             ; prepare current PC
        mov     ebx, [edi + 8]
        shl     ebx, 4                          ; table with 4 procs per copr
        call    [_coproc_tbl + ebx]             ; coprproc0
        pop     esi
        pop     edi
        pop     edx
        pop     edx

        movzx   ecx, ax                         ; PC skip in low word
        add     esi, ecx                        ; inc PC (skip copr instrs)
        test    eax, 10000h
        jnz     i313_Ln                         ; inverted result!
        mov     ebx, [edi + 12]
        dec     word ptr [ebx]                  ; dec Dn
        jc      i314_n                          ; end of loop ?
        mov     ecx, esi
        fetchw
        movsx   edx, dx
        add     esi, edx
i314_n: add     esi, 2
        mov     eax, 0
        ret

;
; Instruction cpGEN
; Table use: 0 - routine, 1 - disasm, 2 - coprocessor, 3 - reg, 4 - srcproc
;

i315_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ecx, esi
        fetchw
        add     esi, 2
        push    edx                             ; prepare command word
        push    offset i313_si                  ; store PC reader
        push    offset i315_rd                  ; store ea reading proc
        push    offset i317_wr                  ; store ea writing proc
        push    edi                             ; prepare table ptr
        push    esi                             ; prepare current PC
        mov     ebx, [edi + 8]
        shl     ebx, 4                          ; table with 4 procs per copr
        call    [_coproc_tbl + 4 + ebx]         ; coprproc1
        pop     esi
        pop     edi
        pop     edx
        pop     edx
        pop     edx
        pop     edx
        movzx   eax, ax
        add     esi, eax                        ; inc PC (skip copr instrs)
        mov     eax, 0
        ret

i315_rd:push    ebp
        mov     ebp, esp
        mov     edi, [ebp + 4]
        mov     edx, [edi + 12]
        call    [edi + 16]
        mov     eax, edx
        pop     ebp
        ret

;
; Instruction cpRESTORE
; Table use: 0 - routine, 1 - disasm, 2 - coprocessor, 3 - reg, 4 -srcproc
;

i316_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        push    offset i315_rd                  ; store reading proc
        push    edi                             ; prepare table ptr
        push    esi                             ; prepare current PC
        mov     ebx, [edi + 8]
        shl     ebx, 4                          ; table with 4 procs per copr
        call    [_coproc_tbl + 8 + ebx]         ; coprproc2
        pop     esi
        pop     edi
        pop     edx
        movzx   eax, ax
        add     esi, eax                        ; inc PC (skip copr instrs)
        mov     eax, 0
        ret

;
; Instruction cpSAVE
; Table use: 0 - routine, 1 - disasm, 2 - coprocessor, 3 - reg, 4 -dstreg
;

i317_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        push    offset i317_wr                  ; store writing proc
        push    edi                             ; prepare table ptr
        push    esi                             ; prepare current PC
        mov     ebx, [edi + 8]
        shl     ebx, 4                          ; table with 4 procs per copr
        call    [_coproc_tbl + 12 + ebx]        ; coprproc3
        pop     esi
        pop     edi
        pop     edx
        movzx   eax, ax
        add     esi, eax                        ; inc PC (skip copr instrs)
        mov     eax, 0
        ret

i317_wr:push    ebp
        mov     ebp, esp
        mov     edi, [ebp + 8]
        mov     edx, [ebp + 4]
        mov     ebx, [edi + 12]
        call    [edi + 16]
        pop     ebp
        ret

;
; Instruction cpScc
; Table use: 0 - routine, 1 - disasm, 2 - coprocessor, 3 - reg, 4 - dstproc
;

i318_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ecx, esi
        fetchw
        add     esi, 2
        and     edx, 3fh
        push    edx                             ; prepare condition
        push    offset i313_si                  ; store PC reader
        push    edi                             ; prepare table ptr
        push    esi                             ; prepare current PC
        mov     ebx, [edi + 8]
        shl     ebx, 4                          ; table with 4 procs per copr
        call    [_coproc_tbl + ebx]             ; coprproc0
        pop     esi
        pop     edi
        pop     ecx
        pop     ecx
        movzx   ecx, ax
        add     esi, eax                        ; inc PC (skip copr instrs)
        mov     dl, 0
        test    eax, 10000h
        jz      i318_1
        dec     dl
i318_1: mov     ebx, [edi + 12]
        call    [edi + 16]
        mov     eax, 0
        ret

;
; Instruction cpTRAPcc
; Table use: 0 - routine, 1 - disasm, 2 - coprocessor, 3 - optype (00/1W/2L)
;

i319_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ecx, esi
        fetchw
        add     esi, 2
        and     edx, 3fh
        push    edx                             ; prepare condition
        push    offset i313_si                  ; store PC reader
        push    edi                             ; prepare table ptr
        push    esi                             ; prepare current PC
        mov     ebx, [edi + 8]
        shl     ebx, 4                          ; table with 4 procs per copr
        call    [_coproc_tbl + ebx]             ; coprproc0
        pop     esi
        pop     edi
        pop     ecx
        pop     ecx
        movzx   ecx, ax
        add     esi, eax                        ; inc PC (skip copr instrs)
        test    eax, 10000h
        jnz     i319_n                          ; condition met
        mov     eax, 0
        ret

i319_n: cmp     dword ptr [edi + 12], 0
        je      i319_0
        mov     ecx, esi
        cmp     dword ptr [edi + 12], 1
        je      i319_1
        fetchl
        add     esi, 4
        jmp     short i319_e
i319_1: fetchw
        add     esi, 2
i319_e:                                         ; here should come
                                                ; trap variable storing!
i319_0: mov     ebx, 7*4 + 80h
	mov     eax, 0
        jmp     prepare_exception_

;
; Instruction DIVS.L <ea>,Dq / <ea>,Dr:Dq / DIVSL <ea>,Dr:Dq       (NZV,C=0)
; Table use: 0 - routine, 1 - disasm, 2 - ear, 3 - scrproc
;

i320_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ebp, esp                        ; stack for lookups
        mov     ecx, esi
        fetchw
        add     esi, 2
        push    edx
        mov     bx, dx
        shl     bx, 2
        and     ebx, 1ch                        ; ebx = Dr
        mov     ax, dx
        rol     ax, 6
        and     eax, 1ch                        ; eax = Dq
        mov     edx, 0
        test    dword ptr [_d + eax], 80000000h ; sign extend to edx ?
        jz      i320ns
	dec     edx
i320ns: test    dword ptr [ebp - 4],  400h      ; size ? (32/64)
        je      i320sm
        ;cmp     ebx, eax                       ; Dr = Dq ?
        ;je      i320sm                         ; 68k doesn't test this !?
        mov     edx, [_d + ebx]
i320sm: push    eax                             ; store Dq on the stack
        mov     eax, [_d + eax]
        push    edx
	mov     edx, [edi+8]
        call    [edi+12]                        ; get (<ea>)
	movzx   ecx, dx
	or      cx, cx
	jz      i320divzero                     ; division by zero!
        pop     edx
        test    dword ptr [ebp - 4], 800h       ; is this DIVS or DIVU ?
        jz      i320ud
        movsx   ecx, cx
        idiv    ecx
        jmp     short i320af

i320ud: cmp     edx, ecx                        ; do we have an overflow ?
        jae     i320overflow
        div     ecx
i320af: mov     ecx, dword ptr _sr
        and     cl, 0f0h
        or      eax, eax
	jnz     i320noz
	or      ecx, 4                          ; Z flag
	jmp     i320end
i320noz:jns     i320end
	or      ecx, 8                          ; N flag
i320end:mov     dword ptr _sr,ecx
        cmp     ebx, [ebp - 8]                  ; Dr = Dq ?
        je      i320nrm
        mov     [_d + ebx], edx                 ; store remainder
i320nrm:pop     ebx
        mov     [_d + ebx, eax                  ; store result
        pop     eax
        mov     eax, 148
	ret

i320divzero:
        pop     eax
        pop     eax
        pop     eax
	mov     ebx, 14h
	mov     eax, 200
        jmp     prepare_exception_

i320overflow:
        and     byte ptr [_sr], 0feh
        or      byte ptr [_sr], 2
        mov     eax, 1
        ret

;
; Instruction EXTB Dn
; Table use: 0 - routine, 1 - disasm, 2 - reg1
; Flag: X unaffected, V = C = 0, NZ
;
i321_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ecx, [edi+8]
	mov     eax, 4              ; AGI
	mov     edx, dword ptr _sr  ; AGI
	and     edx, 0fffffff0h     ; AGI
	mov     ebx, dword ptr [ecx]
	movsx   ebx, bl
	mov     dword ptr [ecx], ebx
	or      ebx, ebx
	jz      i321wz
	jns     i321wns
	or      edx, 8
	jmp     i321wns
i321wz: or      edx, 4
i321wns:mov     dword ptr _sr, edx
	ret

;
; Instruction LINK.L An,#                                          ()
; Table use: 0 - routine, 1 - disasm, 2 - *An
;
i322_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ebx, [edi+8]
	mov     edx, [ebx]                 ; get An
	mov     ecx, [_a+28]
	sub     ecx, 4
	mov     [ebx], ecx                 ; Store new A7 into An
        writel                             ; (A7) <- An
	mov     ebx, ecx
	mov     ecx, esi
        fetchl
	add     esi, 4
	add     ebx, edx
	mov     [_a+28], ebx               ; A7 += #
	mov     eax, 16
	ret

;
; Instruction MOVE CCR,<ea>                                        ()
; Table use: 0 - routine, 1 - disasm, 2 - dstreg, 3 - dstproc, 4 - timing
;
i323_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     dl, byte ptr _sr
        mov     dh, 0
	mov     ebx, [edi + 8]
        call    [edi+12]
	mov     eax,dword ptr [edi+16]
	ret

;
; Instruction MOVEC Rc,Rn / Rn,Rc                                  ()
; Table use: 0 - routine, 1 - disasm
;

i324_W_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        test    byte ptr _sr+1, 20h      ; Are we in supervisormode??
        jz      privilegie_violation
        mov     ecx, esi
        fetchw
        add     esi, 2
        movzx   ebx, dx
        and     bx, 0fffh
        cmp     bx, 3
        jb      i324_Wl
        cmp     bx, 804h
        ja      i324_We
        cmp     bx, 800h
        jb      i324_We                         ; out of bounds
        sub     bx, 7fdh
i324_Wl:shl     bx, 2
        mov     ebx, [i324_tb + ebx]            ; we have *Rc now
        rol     dx, 6
        and     edx, 3ch                        ; we have Rn now
        mov     eax, [_d + edx]
        mov     [ebx], eax                      ; Rc <- Rn
i324_We:mov     eax, 0
	ret

i324_R_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        test    byte ptr _sr+1, 20h      ; Are we in supervisormode??
        jz      privilegie_violation
        mov     ecx, esi
        fetchw
        add     esi, 2
        movzx   ebx, dx
        and     bx, 0fffh
        cmp     bx, 3
        jb      i324_Rl
        cmp     bx, 804h
        ja      i324_Re
        cmp     bx, 800h
        jb      i324_Re                         ; out of bounds
        sub     bx, 7fdh
i324_Rl:shl     bx, 2
        mov     ebx, [i324_tb + ebx]            ; we have *Rc now
        rol     dx, 6
        and     edx, 3ch                        ; we have Rn now
        mov     eax, [ebx]
        mov     [_d + edx], eax                 ; Rn <- Rc
i324_Re:mov     eax, 0
        ret

i324_tb dd      _sfc, _dfc, _cacr, _usp, _vbr, _caar, _msp, _isp

;
; Instruction MOVES Rn,<ea> / <ea>,Rn                              ()
; Table use: 0 - routine, 1 - disasm, 2 - reg
;            3 - arproc,  4 - awproc, 5 - timing
;
; It should use SFC / DFC registers to access memory... Currently, it doesn't

i325_B_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        test    byte ptr _sr+1, 20h      ; Are we in supervisormode??
        jz      privilegie_violation
        mov     ecx, esi
        fetchw
        add     esi, 2
        mov     bx, dx
        rol     bx, 6
        and     ebx, 3ch
        test    dx, 800h
        jz      i325_Br
        mov     edx, [_d + ebx]          ; write to memory
        mov     ebx, [edi + 8]
        call    [edi + 16]
        mov     eax, [edi + 16]
        ret
i325_Br:mov     edx, [edi + 8]
        call    [edi + 12]
        test    bl, 8                    ; is this An register ?
        jz      i325_B1
        movsx   edx, dl
        mov     [_d + ebx], edx
        mov     eax, [edi + 16]
        ret
i325_B1:mov     byte ptr [_d + ebx], dl
        mov     eax, [edi + 16]
        ret

i325_W_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        test    byte ptr _sr+1, 20h      ; Are we in supervisormode??
        jz      privilegie_violation
        mov     ecx, esi
        fetchw
        add     esi, 2
        mov     bx, dx
        rol     bx, 6
        and     ebx, 3ch
        test    dx, 800h
        jz      i325_Wr
        mov     edx, [_d + ebx]          ; write to memory
        mov     ebx, [edi + 8]
        call    [edi + 16]
        mov     eax, [edi + 16]
        ret
i325_Wr:mov     edx, [edi + 8]
        call    [edi + 12]
        test    bl, 8                    ; is this An register ?
        jz      i325_W1
        movsx   edx, dx
        mov     [_d + ebx], edx
        mov     eax, [edi + 16]
        ret
i325_W1:mov     word ptr [_d + ebx], dx
        mov     eax, [edi + 16]
        ret

i325_L_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        test    byte ptr _sr+1, 20h      ; Are we in supervisormode??
        jz      privilegie_violation
        mov     ecx, esi
        fetchw
        add     esi, 2
        mov     bx, dx
        rol     bx, 6
        and     ebx, 3ch
        test    dx, 800h
        jz      i325_Lr
        mov     edx, [_d + ebx]          ; write to memory
        mov     ebx, [edi + 8]
        call    [edi + 16]
        mov     eax, [edi + 16]
        ret
i325_Lr:mov     edx, [edi + 8]
        call    [edi + 12]
        mov     [_d + ebx], edx
        mov     eax, [edi + 16]
        ret

;
; Instruction MULS.L <ea>,Dn / <ea>,Dh:Dl                          (NZV,C=0)
; Table use: 0 - routine, 1 - disasm, 2 - ear, 3 - scrproc
;

i326_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ecx, esi
        fetchw
        add     esi, 2
        mov     bx, dx
        rol     bx, 6
        and     ebx, 1ch
        mov     eax, [_d + ebx]
        push    ebx
        mov     bx, dx
        mov     edx, [edi + 8]
        call    [edi + 12]
        test    bh, 8h
        jz      i326um
        imul    edx
        jmp     short i326cm
i326um: mul     edx
i326cm: pop     ecx
        mov     [_d + ecx], eax
        and     byte ptr _sr, 0f0h
        mov     cl, 0
        test    bh, 4h
        jz      i326_3
        shl     bx, 2
        and     ebx, 1ch
        mov     [_d + ebx], edx
        or      eax, eax
        jnz     i326_1
        or      edx, edx
        jnz     i326_1
        or      cl, 4
i326_1: or      edx, edx
        jns     i326_2
        or      cl, 8
i326_2: or      byte ptr _sr, cl
        mov     eax, 0
        ret

i326_3: or      edx, edx
        jz      i326_4
        or      cl, 2
i326_4: or      eax, eax
        jnz     i326_5
        or      cl, 4
i326_5: or      eax, eax
        jns     i326_6
        or      cl, 8
i326_6: or      byte ptr _sr, cl
        mov     eax, 0
        ret

;
; Instruction PACK -(Ax),-(Ay),# / Dx,Dy,#                         ()
; Table use: 0 - routine, 1 - disasm, 2 - srcear, 3 - scrproc(W)
;            4 - dstear, 5 - dstproc(B)
;

i327_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     edx, [edi + 8]
        call    [edi + 12]
        mov     eax, edx
        mov     ecx, esi
        fetchw
        add     esi, 2
        add     edx, eax
        shl     dh, 4
        and     dl, 0fh
        or      dl, dh
        mov     ebx, [edi + 16]
        call    [edi + 20]
        mov     eax, 0
        ret

;
; Instruction PFLUSH A / <fc>,# / <fc>,#,<ea>                      ()
; Instruction PLOADR <fc>,<ea> / PLOADW <fc>,<ea>                  ()
; Instruction PMOVE reg,<ea> / <ea>,reg / PMOVEFD <ea>,reg         ()
; Instruction PTESTR/W <fc>,<ea>,# / <fc>,<ea>,#,An                ()
; Table use: 0 - routine, 1 - disasm, 2 - srcreg, 3 - srcproc
;
; PFLUSH is not and probably will NEVER be really supported (ATC command)
; PLOAD  is not and probably will NEVER be really supported (ATC command)
; PMOVE  is not yet supported (MMU command)
; PTEST  is not and probably will NEVER be really supported (ATC command)

i328_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        add     esi, 2                  ; skip param word
        mov     eax, 0
        ret

        mov     ecx, esi
        fetchw
        add     esi, 2
        mov     ax, dx
        and     ax, 0e000h
        cmp     ax, 8000h
        jne     i328_e                          ; we want PTEST command only
        test    dh, 1                           ; should we store result
        jz      i328_e                          ; in the An register ?
        ror     dl, 3
        and     edx, 1fh
        mov     dword ptr [_a + edx], 0         ; last descriptor addr
i328_e: mov     eax, 0
        ret

;
; Instruction RTD #                                                ()
; Table use: 0 - routine, 1 - disasm
;

i329_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     ecx, esi
        fetchw
        movsx   eax, dx
        mov     ecx,dword ptr [_a + 28]
        fetchl
	mov     esi, edx
	add     ecx, 4
        add     ecx, eax
	mov     dword ptr [_a + 28], ecx
        mov     eax, 0
        ret

;
; Instruction TRAPcc / .W # / .L #                                 ()
; Table use: 0 - routine, 1 - disasm, 2 - cond handle proc, 3 - mode
;

i330_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        call    [edi + 8]                       ; edx = 1 succeeded
        test    dl, dl
        jz      i330_n
        cmp     dword ptr [edi + 12], 0
        je      i330_0
        mov     ecx, esi
        cmp     dword ptr [edi + 12], 1
        je      i330_w
        fetchl
        add     esi, 4
        jmp     short i330_0
i330_w: fetchw
        add     esi, 2
i330_0: mov     eax, 0
        mov     ebx, 80h + 4*7                  ; make exc 7
        mov     eax, 0
        jmp     prepare_exception_

i330_n: cmp     dword ptr [edi + 12], 0
        je      i330_e
        add     esi, 2
        cmp     dword ptr [edi + 12], 1
        je      i330_e
        add     esi, 2
i330_e: mov     eax, 0
        ret

;
; Instruction UNPK -(Ax),-(Ay),# / Dx,Dy,#                         ()
; Table use: 0 - routine, 1 - disasm, 2 - srcear, 3 - scrproc(B)
;            4 - dstear, 5 - dstproc(W)
;

i331_:
#ifdef PROF68
        inc     dword ptr [_profile]
#endif
        mov     edx, [edi + 8]
        call    [edi + 12]
        mov     ah, dl
        shl     ah, 4
        mov     al, dl
        and     al, 0fh
        mov     ecx, esi
        fetchw
        add     esi, 2
        add     dx, ax
        mov     ebx, [edi + 16]
        call    [edi + 20]
        mov     eax, 0
        ret





_TEXT ends

_DATA segment dword public 'DATA'

include data\memory.inc
include data\68000.inc
include data\68030.inc
include data\68kcopr.inc

_DATA ends

_BSS segment dword public 'DATA'
_BSS ends
end
